/**
 * Created by eeee on 17/1/6.
 */

var GameScene80Layer = cc.Layer.extend({
    weiba:null,
    beganLength:0,
    movedLength:0,
    ctor: function () {
        this._super();

        var weiba=createLevelSprite("t2_80_weiba1.png");
        weiba.attr({
            x:winCenter().x+130.4,y:winCenter().y+-84.2
        });
        this.addChild(weiba);
        this.weiba=weiba;

        var kongque=createLevelSprite("t2_80_kongque.png");
        kongque.attr({
            x:winCenter().x,y:winCenter().y
        });
        this.addChild(kongque);

        setDelay(this,10,function(){
            removeListener(this);
            showWrong();
        })
    },
    getPointLength:function(touches){
        if(touches.length>1){
            var x=touches[0].getLocation().x-touches[1].getLocation().x;
            var y=touches[0].getLocation().y-touches[1].getLocation().y;
            var pointLength=Math.round(Math.sqrt(Math.pow(x,2)+Math.pow(y,2)));

            this.beganLength=this.beganLength>0?Math.min(this.beganLength,pointLength):pointLength;
            this.movedLength=pointLength;
        }
    },
    changeWeiba:function(){
        removeListener(this);
        this.stopAllActions();

        setSpriteTxture(this.weiba,"t2_80_weiba2.png");
        this.weiba.attr({
            x:winCenter().x+2.7,y:winCenter().y+44.8
        });

        setDelay(this,1,function(){
            showRight();
        });
    },
    onEnter:function(){
        this._super();

        var _this=this;

        cc.eventManager.addListener({
            event:cc.EventListener.TOUCH_ALL_AT_ONCE,
            onTouchesBegan:function(touches,event){
                _this.getPointLength(touches);
                return true;
            },
            onTouchesMoved:function(touches,event){
                _this.getPointLength(touches);
            },
            onTouchesEnded:function(touches,event){
                if(_this.beganLength==0 || _this.movedLength==0)return;

                var scale=_this.movedLength/_this.beganLength;
                if(scale>1.6){
                    _this.changeWeiba();
                }

                trace("beganLength:",_this.beganLength,",movedLength:",_this.movedLength,",拖动缩放:",scale);

                _this.beganLength=0;
                _this.movedLength=0;
            }
        },this);
    }
});

var GameScene80 = GameSceneBase.extend({
    layer: null,
    ctor: function () {
        this._super();
        this.layer = new GameScene80Layer();
        this.addChild(this.layer);
    }
});