/**
 * Created by eeee on 17/1/6.
 */

var GameScene85Layer = cc.Layer.extend({
    beganLength:0,
    movedLength:0,
    polygon:null,
    rectangle:null,
    isSetRect:false,
    ctor: function () {
        this._super();
        var _this=this;

        var touchView=new cc.Layer();
        this.addChild(touchView);
        addTouchCallBack(touchView,function(touch){
            var touchPos=touch.getLocation();
            showWrong(touchPos.x,touchPos.y);
        });
        touchView.beganCallback=function(touch){
            var touchPos=touch.getLocation();
            if(_this.isSetRect){
                if(cc.rectContainsPoint(_this.polygon.getBoundingBox(),touchPos)){
                    return false;
                }
            }
            return true;
        }

        var polygon=createLevelSprite("t2_85_polygon.png");
        polygon.attr({
            x:winCenter().x,
            y:winCenter().y+30
        });
        this.addChild(polygon);
        this.polygon=polygon;

        var rect=createRectSprite(30,30);
        rect.attr({
            x:polygon.width/2-30,
            y:polygon.height/2-30,
            opacity:0
        });
        polygon.addChild(rect);


        var rectangle=createLevelSprite("t2_85_rectangle_1.png");
        rectangle.attr({
            x:winCenter().x+22.9,y:winCenter().y+-306.1
        });
        this.addChild(rectangle);
        this.rectangle=rectangle;

        addTouchCallBack(rectangle,function(){
            var rectConvertPos=rect.parent.convertToWorldSpace(rect.getPosition());
            var rect2ConvertPos=rect2.parent.convertToWorldSpace(rect2.getPosition());
            var rectParam=cc.rect(rectConvertPos.x,rectConvertPos.y,rect.width,rect.height);
            var rect2Param=cc.rect(rect2ConvertPos.x,rect2ConvertPos.y,rect2.width,rect2.height);

            //设置好位置
            if(cc.rectIntersectsRect(rectParam,rect2Param)){
                this.setTouchEnabled(false);
                _this.setRect();
            }else{
                showWrong();
            }
        },true,function(touch,event,delta){
            this.x+=delta.x;
            this.y+=delta.y;
        });

        var rect2=createRectSprite(55,55);
        rect2.attr({
            x:rectangle.width/2,
            y:rectangle.height/2,
            opacity:0
        });
        rectangle.addChild(rect2);
    },
    getPointLength:function(touches){
        if(touches.length>1){
            var x=touches[0].getLocation().x-touches[1].getLocation().x;
            var y=touches[0].getLocation().y-touches[1].getLocation().y;
            var pointLength=Math.round(Math.sqrt(Math.pow(x,2)+Math.pow(y,2)));

            this.beganLength=this.beganLength>0?Math.min(this.beganLength,pointLength):pointLength;
            this.movedLength=pointLength;
        }
    },
    setRect:function(){
        var _this=this;
        this.isSetRect=true;

        this.rectangle.attr({
            x:winCenter().x+-29.9,y:winCenter().y
        });

        //添加触摸判断缩放手势
        cc.eventManager.addListener({
            event:cc.EventListener.TOUCH_ALL_AT_ONCE,
            swallowTouches:true,
            onTouchesBegan:function(touches,event){
                _this.getPointLength(touches);
                return true;
            },
            onTouchesMoved:function(touches,event){
                _this.getPointLength(touches);
            },
            onTouchesEnded:function(touches,event){
                if(_this.beganLength==0 || _this.movedLength==0)return;

                var scale=_this.movedLength/_this.beganLength;
                if(scale>1.8){
                    createUnTouchLayer(0,false);
                    setSpriteTxture(_this.rectangle,"t2_85_rectangle_2.png");
                    _this.rectangle.attr({
                        x:winCenter().x+-25.8,y:winCenter().y+3
                    });

                    setDelay(_this,1,function(){
                        showRight();
                    });
                }

                trace("beganLength:",_this.beganLength,",movedLength:",_this.movedLength,",拖动缩放:",scale);

                _this.beganLength=0;
                _this.movedLength=0;
            }
        },this.polygon);
    }
});

var GameScene85 = GameSceneBase.extend({
    layer: null,
    ctor: function () {
        this._super();
        this.layer = new GameScene85Layer();
        this.addChild(this.layer);
    }
});