/**
 * Created by weicheng on 15/10/13.
 *
 * 兑换码窗口
 */

var ExchangeLayer=PanelViewBase.extend({
    ctor:function(){
        this._super();
        this.initSurface();
    },
    initSurface:function(){

        var _this=this;

        this.frame=createLevelSprite("panel_2");
        this.nodeUI_.addChild(this.frame);

         //标题
         var titleBg = createSprite(getResImg("panel_title","res_Panel"));
        titleBg.attr({
             x: this.frame.width / 2,
             y: this.frame.height
         });
         this.frame.addChild(titleBg);

        var title = createLabel("兑换", 47,cc.color(79,76,75));
        title.attr({
            x: titleBg.width / 2+15,
            y: titleBg.height/2-2
        });
        titleBg.addChild(title);


        var box=createScale9Sprite(getLevelImg("duihuan_kuang","res_Panel"));
        box.y=30;
        box.opacity=0;
        this.nodeUI_.addChild(box);
        this.box=box;

        var textFiled=new cc.EditBox(cc.size(388,94),createScale9Sprite(getLevelImg("duihuan_kuang","res_Panel")));
        textFiled.x=box.width/2;
        textFiled.y=box.height/2;
        textFiled.setMaxLength(40);
        textFiled.setDelegate(this);
        textFiled.setFontSize(40);
        textFiled.setPlaceholderFontSize(40);
        if(isMobile("iOS")){
            textFiled.setPlaceHolder("请输入兑换码");
        }
        box.addChild(textFiled);
        this.textFiled=textFiled;

        //兑换按钮
        var exchangeBtn=createButton({img:getLevelImg("btn_duihuan","res_Panel")});
        exchangeBtn.y=-110;
        this.nodeUI_.addChild(exchangeBtn);
        //var buyLabel=new cc.LabelTTF("兑 换","",30);
        //buyLabel.attr({
        //    x:exchangeBtn.width/2,
        //    y:exchangeBtn.height/2,
        //    color:cc.color(56,66,85)
        //});
        //exchangeBtn.addChild(buyLabel);
        exchangeBtn.callback=function(){
            var exChangeText=textFiled.string.replace(/ /g,"");
            cc.log("兑换码信息："+exChangeText);
            if(exChangeText.length>0){
                if(isExChange(exChangeText)){
                    if(isMobile()){
                        var loadingLayer=new LoadingLayer();
                        loadingLayer.addToCurScene();
                        CommonPlatform.getInstance().exchangeCallBack=function(data){
                            loadingLayer.onClose();
                            if(data && data!=""){
                                _this.showChangeList(data,exChangeText);
                            }else {
                                if(isMobile("iOS")){
                                    showToast("无效兑换码",cc.color(255,0,0));
                                }
                            }
                        };
                        CommonPlatform.getInstance().exchange(exChangeText);
                    }
                }else{
                    showToast("兑换码已使用",cc.color(255,0,0));
                }
            }else{
                textFiled.string="";
                showToast("请输入兑换码",cc.color(255,0,0));
            }
        };
        this.exchangeBtn=exchangeBtn;


        //关闭按钮
        var closeBtn = createButton({img: getResImg("guanq_prompt_btn6.png")});
        closeBtn.attr({
            x: this.frame.width - 20,
            y: this.frame.height - 20
        });
        this.frame.addChild(closeBtn);
        closeBtn.callback = function () {
            this.onClose(this.closeCallback);
        }.bind(this);



        //确定按钮
        var confirmBtn=createButton({img:getLevelImg("guanq_prompt_btn5")});
        confirmBtn.y=-110;
        confirmBtn.visible=false;
        this.nodeUI_.addChild(confirmBtn);
        var confirmLabel=new cc.LabelTTF("确 定","",30);
        confirmLabel.attr({
            x:confirmBtn.width/2,
            y:confirmBtn.height/2,
            color:cc.color(56,66,85)
        });
        confirmBtn.addChild(confirmLabel);
        confirmBtn.callback=function(){
            this.onClose();
        }.bind(this);
        this.confirmBtn=confirmBtn;


        var icon=createSprite(getLevelImg("guanq_btn_key"));
        icon.y=50;
        icon.visible=false;
        this.nodeUI_.addChild(icon);
        this.keyIcon=icon;

        return true;
    },

    editBoxEditingDidBegin: function (editBox) {
        //获取焦点
    },
    editBoxEditingDidEnd: function (editBox) {
        //失去焦点
    },
    editBoxTextChanged: function (editBox, text) {
        //内容改变
    },
    editBoxReturn: function (editBox) {
        //内容输入完毕
    },
    showChangeList:function(data,exChangeText){
        if(isExChange(exChangeText)){
            setExchangeStr(exChangeText);

            cc.log("当前兑换码："+exChangeText);
            try{
                cc.log("兑换数据："+data);
                var json=JSON.parse(data);
                if(isMobile("Android")){
                    if(json.data){
                        this.createChangeItem(json.data[0]);
                    }
                }else{
                    if(json){
                        this.createChangeItem(json[0]);
                    }
                }
                this.box.visible=false;
                this.textFiled.visible=false;
                this.exchangeBtn.visible=false;
                //this.titleLabel.string="兑换成功";

                // //确定按钮
                // var confirmBtn=createScale9Button({img:getResImg("guanq_prompt_btn5")});
                // confirmBtn.y=-110;
                // this.nodeUI_.addChild(confirmBtn);
                // var confirmLabel=new cc.LabelTTF("确 定","",30);
                // confirmLabel.attr({
                //     x:confirmBtn.width/2,
                //     y:confirmBtn.height/2,
                //     color:cc.color(56,66,85)
                // });
                // confirmBtn.addChild(confirmLabel);
                // confirmBtn.callback=function(){
                //     this.onClose();
                // }.bind(this);
                this.confirmBtn.visible=true;
            }catch(err){
                cc.log("兑换码错误："+err);
            }
        }


    },
    createChangeItem:function(itemData){

        // var iconStr;
        var nameStr=itemData.productName;

        switch (itemData.productKey){
            case "key":
                // iconStr=getLevelImg("guanq_btn_key");
                this.keyIcon.visible=true;
                nameStr+="x"+itemData.value;
                addGoldNum(itemData.value,true);
                break;
            default :
                break;
        }

        // if(iconStr){
        //     var icon=createSprite(iconStr);
        //     icon.y=50;
        //     this.nodeUI_.addChild(icon);
        // }

        var label=new cc.LabelTTF(nameStr,"",30);
        label.attr({
            color:cc.color(56,66,85),
            y:-30
        })
        this.nodeUI_.addChild(label);

    }
});