/**
 * Created by weicheng on 15/10/9.
 *
 * 暂停窗口
 */

var PauseGameLayer = PanelViewBase.extend({
    ctor: function () {
        this._super();

        this.initSurface();
    },
    initSurface: function () {
        if (isMobile("Android")) {
            CommonPlatform.getInstance().gamePause();
        }

        //外框
        var frame = createSprite(getResImg("failure_bg", "res_GameOver"));
        frame.scaleY = 0.8;
        this.nodeUI_.addChild(frame);

        //音乐文本
        var musicTxt = createSprite(getResImg("pause_txt_music", "res_GameOver"));
        musicTxt.attr({
            x: -150,
            y: 70
        });
        this.nodeUI_.addChild(musicTxt);

        //音乐开关按钮
        var musicOffBtn = createButton({img: getResImg(getMusicOffStatus() == "0" ? "pause_music_close" : "pause_music_open", "res_GameOver")});
        musicOffBtn.attr({
            x: 0,
            y: 70
        });
        this.nodeUI_.addChild(musicOffBtn);
        musicOffBtn.callback = function () {
            if (getMusicOffStatus() == "0") {
                setSoundOpenOrNot(true);
                setScale9SpriteTexture(this, getResImg("pause_music_open", "res_GameOver"));
            } else {
                setSoundOpenOrNot(false);
                setScale9SpriteTexture(this, getResImg("pause_music_close", "res_GameOver"));
            }
        };

        //坑爹男
        var man = createSprite(getResImg("pause_man", "res_GameOver"));
        man.attr({
            x: 160,
            y: 80
        });
        this.nodeUI_.addChild(man);

        if (isBrowser()) {
            addTouchCallBack(man, function () {
                if (isTestMode != 1) {
                    isTestMode = 1;
                } else {
                    isTestMode = 0;
                }
                trace("isTestMode:", isTestMode);
            });
        }


        var homeBtn;
        if (isWeb == 1 && isWebTest != 1) {

        } else {
            //返回菜单按钮
            homeBtn = createButton({img: getResImg("pause_btn_home", "res_GameOver")});
            homeBtn.attr({
                x: -160,
                y: -65
            });
            this.nodeUI_.addChild(homeBtn);
            homeBtn.callback = function () {
                removeLevelScenePlist(function () {
                    try {
                        cc.director.runScene(new LevelSelectScene());
                    } catch (err) {
                        _resumeGame();
                        cc.director.runScene(new LevelSelectScene());
                    }
                });
            }.bind(this);
        }


        //继续按钮
        var continueBtn = createButton({img: getResImg("pause_btn_continue", "res_GameOver"), soundOff: false});
        continueBtn.attr({
            x: 0,
            y: -65
        });
        this.nodeUI_.addChild(continueBtn);
        continueBtn.callback = function () {
            _resumeGame();
            this.onClose();
        }.bind(this);

        //重来按钮
        var againBtn = createButton({img: getResImg("pause_btn_restart", "res_GameOver")});
        againBtn.attr({
            x: 160,
            y: -65
        });
        this.nodeUI_.addChild(againBtn);
        againBtn.callback = function () {
            try {
                cc.director.runScene(eval("new " + getClassName(this.getParent().level) + "()"));
            } catch (err) {
                _resumeGame();
                try {
                    cc.director.runScene(eval("new " + getClassName(this.getParent().level) + "()"));
                } catch (err) {
                    cc.director.runScene(new HelloWorldScene());
                }
            }
        }.bind(this);
    }
});