/**
 * Created by weicheng on 15/10/7.
 *
 * 商店
 */

var StoreLayer=PanelViewBase.extend({
    ctor:function(){
        this._super();
        this.initSurface();
    },
    initSurface:function(){

        imgSearchPath="res_store";

        //背景
        var bg=createSprite(getResImg("panel_1","res_store"));
        this.nodeUI_.addChild(bg);
        this.storeFrame=bg;

        //标题
        var titleBg=createLevelSprite("panel_title.png");
        titleBg.attr({
            x:bg.width/2,
            y:bg.height-titleBg.height/2+10
        });
        bg.addChild(titleBg);

        var title = createLabel("商店", 47,cc.color(79,76,75));
        title.attr({
            x: titleBg.width / 2+15,
            y: titleBg.height/2-2
        });
        titleBg.addChild(title);

        //关闭按钮
        var closeBtn=createButton({img:getResImg("shangchang_btn_guan","res_store"),soundOff:false});
        closeBtn.attr({
            x:bg.width-20,
            y:bg.height-25
        });
        bg.addChild(closeBtn);
        closeBtn.callback=function(){
            this.onClose();
        }.bind(this);

        //装饰
        var apple=createLevelSprite("panel_apple.png");
        apple.attr({
            x:65,
            y:85
        });
        bg.addChild(apple);

        //按钮列表
        this.createBtnList();

        if(isOpen("outAdTips")){
            var outAdTips=createLevelSprite("outAdTips");
            outAdTips.attr({
                x:0,
                y:-210
            });
            this.nodeUI_.addChild(outAdTips);
        }

        if(cc.director.getWinSize().width/cc.director.getWinSize().height < 0.53){
            bg.scale = 0.75
        }


        //返回按键监听
        cc.eventManager.addListener({
            event: cc.EventListener.KEYBOARD,
            onKeyReleased: function (keyCode, event) {
                if (keyCode == 6) {
                    // cc.director.runScene(new MainScene());
                    CommonPlatform.getInstance().exit();
                }
            }
        }, this);

    },
    createBtnList:function(){

        var goldList=[];

        //无限钥匙：30元
        var goldBtn1=createButton({img:getResImg("shangchang_xiaokuang1","res_store")});
        this.storeFrame.addChild(goldBtn1);
        goldBtn1.callback=function(){

            if(isMobile()) {

                CommonPlatform.getInstance().buy(1005);
            }
        }
        goldList.push(goldBtn1);

        //50钥匙：20元
        var goldBtn2=createButton({img:getResImg("shangchang_xiaokuang2","res_store")});
        this.storeFrame.addChild(goldBtn2);
        goldBtn2.callback=function(){
            if(isMobile()) {

                CommonPlatform.getInstance().buy(1004);
            }
        }
        goldList.push(goldBtn2);

        //20钥匙：12元
        var goldBtn3=createButton({img:getResImg("shangchang_xiaokuang3","res_store")});
        this.storeFrame.addChild(goldBtn3);
        goldBtn3.callback=function(){

            if(isMobile()) {

                CommonPlatform.getInstance().buy(1003);
            }
        }
        goldList.push(goldBtn3);

        //8钥匙：6元
        var goldBtn4=createButton({img:getResImg("shangchang_xiaokuang4","res_store")});
        this.storeFrame.addChild(goldBtn4);
        goldBtn4.callback=function(){

            if(isMobile()) {

                CommonPlatform.getInstance().buy(1002);
            }
        }
        goldList.push(goldBtn4);

        //1钥匙：1元
        var goldBtn5=createButton({img:getResImg("shangchang_xiaokuang5","res_store")});
        this.storeFrame.addChild(goldBtn5);
        goldBtn5.callback=function(){

            if(isMobile()) {

                CommonPlatform.getInstance().buy(1001);
            }
        }
        goldList.push(goldBtn5);



        for(var i=0;i<goldList.length;i++){
            var row=Math.floor(i/3);
            if(row!=0){
                goldList[i].x=this.storeFrame.width/2-90+(i-row*3)*180;
            }else{
                goldList[i].x=this.storeFrame.width/2-155+(i-row*3)*155;
            }
            goldList[i].y=340-row*157;
        }



    },
    createBtnItem:function(iconPath,goldNum,money){
        var btn=createButton({img:getResImg("shop_gold_frame","res_storeLayer")});
        var icon=createSprite(iconPath);
        icon.attr({
            anchorY:0,
            x:btn.width/2,
            y:63
        });
        btn.addChild(icon);

        var goldLabel=new cc.LabelTTF("+ "+goldNum,"",24);
        goldLabel.attr({
            x:btn.width/2,
            y:47,
            color:cc.color(120,40,11)
        });
        btn.addChild(goldLabel);

        var moneyFrame=createSprite(getResImg("box_btn_buy"));
        moneyFrame.attr({
            x:btn.width/2,
            y:2,
            scale:0.7
        });
        btn.addChild(moneyFrame);

        var moneyLabel=new cc.LabelTTF(money,"",44);
        moneyLabel.attr({
            x:moneyFrame.width/2,
            y:moneyFrame.height/2,
            color:cc.color(37,52,62)
        });
        moneyFrame.addChild(moneyLabel);

        if(getChannel()=="google"){
            moneyLabel.string="HKD "+money;
        }else{
            moneyLabel.string+="元";
        }

        return btn;
    },
    createBtnItem2:function(iconPath,btnName,callback){
        var btn=createButton({img:getResImg("shop_free_frame","res_storeLayer")});

        var icon=createSprite(iconPath);
        icon.attr({
            anchorY:0,
            x:btn.width/2,
            y:12
        });
        btn.addChild(icon);

        var nameLabel=new cc.LabelTTF(btnName,"",20);
        nameLabel.attr({
            x:btn.width/2,
            y:28,
            color:cc.color(93,71,67)
        });
        btn.addChild(nameLabel);
        btn.label=nameLabel;

        return btn;
    },
    onEnter:function(){
        this._super();
//        if(isMobile("iOS")){
//            CommonPlatform.getInstance().showVideoAdBtn("cb",0,90);
//        }
    },
    onExit:function(){
        this._super();
//        if(isMobile("iOS")){
//            CommonPlatform.getInstance().hideVideoAdBtn();
//        }
    }
});