/**
 * Created by weicheng on 15/10/6.
 *
 * 游戏场景类
 */
var GameSceneBase = cc.Scene.extend({
    level: 1, //当前关卡序号
    _className: "GameSceneBase",//关卡类名
    _menuLayer: null,    //菜单栏
    _bgFile: null,
    state: 0, //场景状态、0：游戏中，1：胜利，2：失败
    ctor: function () {
        this._super();
        cc.director.getRunningScene().cleanup();

        //音效清除
        effectArray = [];

        var _this = this;

        this.level = _preSelectLevel || 1;
        this._className = getClassName(this.level);
        this.size = cc.director.getWinSize();
        this.initSurface();

        stopAllEffect();
        stopMusic();

        this.state = 0;

        curMusicIndex = 2;
        try {
            //var musicPath = eval("res_" + getClassName(this.level) + "_sound");
            //if (musicPath) {
            //    var music = musicPath["bg_mp3"];
            //    if (music)playMusic(music, true);
            //}
            //music = musicPath["bg_mp3"];
            playMusic(res_sound.brackgroundmusic_mp3, true);
        } catch (err) {
            trace("背景音乐找不到：" + err);
        }

        //设置游戏总时长
        setGameTime();

        //设置当前选择的关卡，用于重开游戏时选关页面定位到当前关卡页
        setSelectLevel(this.level);

        if (isMobile()) {
            //友盟统计
            CommonPlatform.getInstance().umengStartLevel(getClassName(this.level));
        }

        cc.eventManager.addCustomListener(cc.game.EVENT_HIDE, function () {
            if (_this.state == 0) {
                _this.pauseTheGame();
            }
        });
        cc.eventManager.addCustomListener(cc.game.EVENT_SHOW, function () {
            if (_this.state == 0) {
                _this.resumeTheGame();
            }
        });


        if (isBrowser() && isTestMode == 1) {
            cc.eventManager.addListener(cc.EventListener.create({
                event: cc.EventListener.MOUSE,
                onMouseDown: function (event) {

                    trace("----------------------begin--------------------------");
                    trace("为方便屏幕定位，提供了鼠标点击位置，发布时可移除!");

                    trace("点击位置 ： \nX = " + Math.round(event._prevX) + "   Y = " + Math.round(event._prevY));
                    trace("相对于屏幕中心的偏移量 ： \n X = " + Math.round(event._prevX - winCenter().x) + "   Y = " + Math.round(event._prevY - winCenter().y));

                    trace("-----------------------end-------------------------");

                    return true;
                },
                onMouseUp: function (event) {
                    //trace("Mouse up");
                    return true;
                }
            }), this);

            //拖动框————对位置
            var rectSprite = new cc.DrawNode();
            this.addChild(rectSprite, 9999);
            rectSprite.initialX = 0;
            rectSprite.initialY = 0;

            var valueLabel = createLabel("", 16);
            valueLabel.color = cc.color(255, 255, 255);
            valueLabel.lineWidth = 3;
            valueLabel.strokeStyle = cc.color(0, 0, 0);
            valueLabel.anchorX = 0;
            valueLabel.anchorY = 0;
            valueLabel.x = 20;
            valueLabel.y = 20;
            rectSprite.addChild(valueLabel);

            try {
                cc.eventManager.addListener({
                    event: cc.EventListener.TOUCH_ONE_BY_ONE,
                    swallowTouches: false,
                    onTouchBegan: function (touch, event) {
                        if (isTestMode == 1) {
                            var pos = touch.getLocation();
                            rectSprite.visible = true;
                            rectSprite.initialX = pos.x;
                            rectSprite.initialY = pos.y;
                            valueLabel.string = "";
                            return true;
                        }
                        return false;
                    },
                    onTouchMoved: function (touch, event) {
                        var pos = touch.getLocation();
                        //_this.rectSprite.attr({
                        //    width:Math.abs(pos.x-_this.rectSprite.x),
                        //    height:Math.abs(pos.y-_this.rectSprite.y)
                        //});
                        rectSprite.clear();
                        rectSprite.drawRect(
                            cc.p(rectSprite.initialX, rectSprite.initialY),
                            cc.p(pos.x, pos.y),
                            cc.color(255, 0, 0, 80),
                            2
                        );

                        var rectSize = cc.size((pos.x - rectSprite.initialX).toFixed(1), (pos.y - rectSprite.initialY).toFixed(1));
                        valueLabel.string = "beginPos：[" + rectSprite.initialX.toFixed(1) + "，" + rectSprite.initialY.toFixed(1) + "]" +
                            "\ncurPos：[" + pos.x.toFixed(1) + "，" + pos.y.toFixed(1) + "]" +
                            "\nanchorPos：[" + (pos.x - rectSize.width / 2).toFixed(1) + "，" + (pos.y - rectSize.height / 2).toFixed(1) + "]" +
                            "\nsize：[" + Math.abs(rectSize.width) + "，" + Math.abs(rectSize.height) + "]" +
                            "\nbeginWinPos：[" + (rectSprite.initialX - winCenter().x).toFixed(1) + "，" + (rectSprite.initialY - winCenter().y).toFixed(1) + "]" +
                            "\ncurWinPos：[" + (pos.x - winCenter().x).toFixed(1) + "，" + (pos.y - winCenter().y).toFixed(1) + "]" +
                            "\nanchorWinPos：[" + ((pos.x - winCenter().x) - rectSize.width / 2).toFixed(1) + "，" + ((pos.y - winCenter().y) - rectSize.height / 2).toFixed(1) + "]";
                    },
                    onTouchEnded: function (touch, event) {
                        rectSprite.clear();
                        rectSprite.visible = false;
                        valueLabel.string = "";
                    }
                }, this);
            } catch (err) {
                trace("测试拖拉区域报错：" + err);
            }
        }


        //返回按键监听
        cc.eventManager.addListener({
            event: cc.EventListener.KEYBOARD,
            onKeyReleased: function (keyCode, event) {
                if (keyCode == 6) {
                    // cc.director.runScene(new MainScene());
                    CommonPlatform.getInstance().exit();
                }
            }
        }, this);


        return true;
    },
    gameWrong: function (x, y, scale,lossWordKey) {
        var layer = new duicuoLayer(x, y, scale,lossWordKey);
        this.addChild(layer, 99);
    },
    gameRight: function (x, y, scaleX, scaleY) {
        var layer = new duiLayer(x, y, scaleX, scaleY);
        this.addChild(layer, 99);
    },
    showGameWin: function () {
        this.gameWin();
    },
    showGameOver: function () {
        this.gameOver();
    },
    gameOver: function (faileKey, lossType) {
        faileKey = faileKey || "lossWord1";

        this.gameOverCallBack(faileKey);
    },
    gameWin: function (winWordKey, winType) {

        this.gameWinCallBack(winWordKey, winType);
    },
    gameOverCallBack: function (faileKey) { //faileKey:文案键名（对应失败文案）
        trace("GameOver！");
        _pauseGame();
        this.unAllSchedule();

        this.rotation = 0;
        this.state = 2;

        //设置游戏总时长
        setGameTime();

        //添加死亡次数
        addLossCount();

        if (isMobile()) {
            //友盟统计
            CommonPlatform.getInstance().umengfailLevel(getClassName(this.level));
        }

        //插屏广告
        // _faileCount++;
        // if (isMobile()) {
        //     if (adHz > 0 && _faileCount % adHz == 0) {
        //         if (isShieldGdt == 1) {
        //             CommonPlatform.getInstance().showInterstitialAd();
        //         } else {
        //             CommonPlatform.getInstance().showInterstitialAd2();
        //         }
        //     }
        //     trace("广告频率：" + adHz + ", 当前次数：" + _faileCount % adHz);
        // }

        playEffect(res_sound.faile1_wav);

        var layer = new PanelViewBase();
        this.addChild(layer, 99);

        var frame = createSprite(getResImg("guanq_kuang_bg.png", "res_GameOver"));
        layer.nodeUI_.addChild(frame);

        //文案背景
        // var wordBg = createSprite(getResImg("failure_dialog.png", "res_GameOver"));
        // wordBg.attr({
        //     x: frame.width / 2 + 100,
        //     y: frame.height / 2 + 85
        // });
        // frame.addChild(wordBg);

        //失败文案
        //var faileWordLabel = new cc.LabelTTF(getWordByKey(faileKey), "SentyMaruko-02-SP", 24, cc.size(275, 100), cc.TEXT_ALIGNMENT_CENTER, cc.VERTICAL_TEXT_ALIGNMENT_CENTER);
        var faileWordLabel = createLabel(getWordByKey(faileKey), 26, cc.color(255, 255, 255), cc.size(345, 155), cc.TEXT_ALIGNMENT_CENTER, cc.VERTICAL_TEXT_ALIGNMENT_CENTER);
        faileWordLabel.attr({
            x: frame.width / 2 + 55,
            y: frame.height / 2 + 55
        });
        frame.addChild(faileWordLabel);

        //坑爹男
        var animNumFrames = [0, 1, 0, 1, 0, 1, 2, 3, 4, 5, 6, 5, 6, 5, 6, 5, 4, 3, 2, 1];
        var animFrames = [];
        var repeatAnimNum = 0;
        for (var i = 0; i < animNumFrames.length; i++) {
            var repeat = false;
            for (var j = 0; j < i; j++) {
                if (animNumFrames[i] == animNumFrames[j]) {
                    repeat = true;
                    repeatAnimNum = j;
                    break;
                }
            }
            animFrames[i] = repeat ? animFrames[repeatAnimNum] : getResImg("failure_man_" + animNumFrames[i] + ".png", "res_GameOver");
        }
        var man = createSprite(getResImg("failure_man_1.png", "res_GameOver"));
        man.attr({
            x: frame.width / 2 - 190,
            y: 140
        });
        frame.addChild(man);
        setAnimation(man, 0.2, animFrames);

        //返回菜单按钮
        var exitBtn = createButton({img: getResImg("guanq_btn_Level.png", "res_GameOver")});
        exitBtn.attr({
            x: frame.width / 2 - 20,
            y: frame.height / 2 - 90
        });
        frame.addChild(exitBtn);
        exitBtn.callback = function () {
            stopAllEffect();
            removeLevelScenePlist(function () {
                cc.director.runScene(new LevelSelectScene());
            });
        }.bind(this);

        //重来按钮
        var againBtn = createButton({img: getResImg("guanq_btn_sxin.png", "res_GameOver")});
        againBtn.attr({
            x: frame.width / 2 + 80,
            y: frame.height / 2 - 90
        });
        frame.addChild(againBtn);
        againBtn.callback = function () {
            stopAllEffect();
            addLevelSpriteFrames(getClassName(this.level));
            try {
                cc.director.runScene(eval("new " + getClassName(this.level) + "()"));
            } catch (err) {
                cc.director.runScene(new HelloWorldScene());
            }
        }.bind(this);


        //商店
        var storeBtn = createButton({img: getResImg("shangchang_btn_sahngchang.png", "res_store")});
        storeBtn.attr({
            x: frame.width / 2 + 180,
            y: frame.height / 2 - 90
        });
        frame.addChild(storeBtn);
        storeBtn.callback = function () {
            new StoreLayer().addToCurScene();
        };


        //求助按钮
        if(!isHideShare()) {
            var helpBtn = createButton({img: getResImg("guanq_btn_qiuz.png", "res_GameOver")});
            helpBtn.attr({
                x: frame.width,
                y: -frame.height + 90
            });
            frame.addChild(helpBtn);
            helpBtn.callback = function () {
                trace("求助");
                share(1002);
            }.bind(this);
        }

        // showPackage(2);

        //展示游戏失败广告位
        showAd("gameOver");

    },
    gameWinCallBack: function (winWordKey, winType) {
        trace("GameWin！");
        _pauseGame();
        this.unAllSchedule();

        this.rotation = 0;
        this.state = 1;

        //设置游戏总时长
        setGameTime();

        if (isMobile()) {
            //友盟统计
            CommonPlatform.getInstance().umengFinishLevel(getClassName(this.level));
        }

        // if (isMobile("iOS") && isReview != 1) {
        //     CommonPlatform.getInstance().comment("求评价", "程序猿哥哥说了，给个评价，下次会做得更好！评价后不再提示哦！", "评价并不再提示", "残忍拒绝");
        // }

        _winCount++;

        //设置游戏已全通关
        if (this.level == gameMaxLevel) {
            setIsLevelAllPass(1);
        }

        playEffect(res_sound.win_wav);

        //胜利文案键值
        winWordKey = winWordKey || "winWord";

        //获取当前关卡是否首次通过
        var isFirstPass = false;

        //跳过金币消耗提示
        // if (winType == 1) {
        //     showGoldChange(-100);
        // }

        if (getLevelStatusByLevel(this.level) != 1) {
            //首次通关加金币
            addGoldNum(1,true);

            // var keyBtn = this._menuLayer.getChildByTag(9);
            // var num = keyBtn.getChildByTag(10);
            // num.setString("" + getGoldNum());

            // showGoldChange(2);
            // setTimeout(function () {
            //     addGoldNum(2);
            // }, 2000);

            //修改关卡通关状态
            setLevelStatusByLevel(this.level, 1);

            isFirstPass = true;
        }

        var layer = new PanelViewBase();
        this.addChild(layer, 99);

        var frame = createSprite(getResImg("guanq_kuang_bg.png", "res_GameOver"));
        layer.nodeUI_.addChild(frame);

        //文案背景
        // var wordBg = createSprite(getResImg("failure_dialog.png", "res_GameOver"));
        // wordBg.attr({
        //     x: frame.width / 2 + 100,
        //     y: frame.height / 2 + 85
        // });
        // frame.addChild(wordBg);

        //通关文案
        //var winWordLabel = new cc.LabelTTF(winType != 1 ? getWordByKey(winWordKey) : "鄙视用金币过关的人！", "SentyMaruko-02-SP", 24, cc.size(275, 100), cc.TEXT_ALIGNMENT_CENTER, cc.VERTICAL_TEXT_ALIGNMENT_CENTER);
        var winWordLabel = createLabel(winType != 1 ? getWordByKey(winWordKey) : "鄙视用金币过关的人！", 26, cc.color(255, 255, 255), cc.size(345, 155), cc.TEXT_ALIGNMENT_CENTER, cc.VERTICAL_TEXT_ALIGNMENT_CENTER);
        winWordLabel.attr({
            x: frame.width / 2 + 55,
            y: frame.height / 2 + 55
        });
        frame.addChild(winWordLabel);

        //坑爹男
        var animFrames = [2, 3, 4, 5, 6, 5, 4, 3, 2, 1];
        for (var i = 0; i < animFrames.length; i++) {
            animFrames[i] = getResImg("win_man_" + animFrames[i] + ".png", "res_GameOver");
        }
        var animateAction = getAnimation(0.08, animFrames);
        var man = createSprite(getResImg("win_man_1.png", "res_GameOver"));
        man.attr({
            x: frame.width / 2 - 205,
            y: 155,
            scale:0.9
        });
        frame.addChild(man);
        man.runAction(cc.sequence(animateAction, cc.delayTime(0.5)).repeatForever());

        //返回菜单按钮
        var exitBtn = createButton({img: getResImg("guanq_btn_Level.png", "res_GameOver")});
        exitBtn.attr({
            x: frame.width / 2-20,
            y: frame.height / 2 - 90
        });
        frame.addChild(exitBtn);
        exitBtn.callback = function () {
            stopAllEffect();
            if (this.level < gameMaxLevel) {
                removeLevelScenePlist(function () {
                    cc.director.runScene(new LevelSelectScene());
                });
            } else {
                _preSelectLevel = 0;
                new AllLevelPassLayer().addToCurScene();
            }


        }.bind(this);


        //初始化关卡文案
        if(this.level<gameMaxLevel) {
            initLevelWordConfig(getClassName(this.level + 1));
        }

        //下一关按钮
        var nextBtn = createButton({img: getResImg("guanq_btn_xiaxiang.png", "res_GameOver")});
        nextBtn.attr({
            x: frame.width / 2 + 80,
            y: frame.height / 2 - 90
        });
        frame.addChild(nextBtn);
        nextBtn.callback = function () {
            stopAllEffect();
            if (this.level < gameMaxLevel) {
                // cc.director.runScene(new ReadyScene(this.level + 1));

                var _level=this.level+1;
                _preSelectLevel = _level;

                cc.director.getRunningScene().cleanup();
                removePlistCache();

                //添加关卡资源
                addLevelSpriteFrames(getClassName(_level));

                removeMainScenePlist(function () {
                    try {
                        cc.director.runScene(eval("new " + getClassName(_level) + "()"));
                    } catch (err) {
                        trace("场景有错误（自动跳到测试页面）：" + err);
                        cc.director.runScene(new HelloWorldScene());
                    }
                });

            } else {
                _preSelectLevel = 0;
                layer.removeFromParent();

                new AllLevelPassLayer().addToCurScene();
            }
        }.bind(this);

        //炫耀按钮
        if(!isHideShare()) {
            var shareBtn = createButton({img: getResImg("guanq_btn_xyao.png", "res_GameOver")});
            shareBtn.attr({
                x: frame.width / 2 + 180,
                y: frame.height / 2 - 90
            });
            frame.addChild(shareBtn);
            shareBtn.callback = function () {
                trace("炫耀");
                share(1003);
            }.bind(this);
        }

        showPackage(1);

        //展示游戏胜利广告位
        showAd("gameWin");

    },
    unAllSchedule: function () {
        this.unscheduleAllCallbacks();
        for (var i = 0; i < this.getChildren().length; i++) {
            this.getChildren()[i].unscheduleAllCallbacks();
        }
    },
    onExit: function () {
        this._super();
        if (isMobile()) {
            CommonPlatform.getInstance().removeBanner();
        }
    },
    onEnter: function () {
        this._super();

        addBackground(this._bgFile, this);//设备背景图片

        if (isMobile()) {
            CommonPlatform.getInstance().showBanner();
        }
    },
    pauseTheGame: function () {
        trace("暂停游戏处理");
    },
    resumeTheGame: function () {
        trace("恢复游戏处理");
    },
    hideMenuGoldBtn: function () { //隐藏金币按钮
        this._menuLayer.goldBtn.visible = false;
    },
    showMenuGoldBtn: function () { //隐藏金币按钮
        this._menuLayer.goldBtn.visible = true;
    },
    hideMenuTipsBtn: function () { //隐藏提示按钮
        this._menuLayer.tipsBtn.visible = false;
    },
    showMenuTipsBtn: function () { //显示提示按钮
        this._menuLayer.tipsBtn.visible = true;
    },
    initSurface: function () {
        this._menuLayer = new GameMenuLayer();
        this.addChild(this._menuLayer, 98);

        //关卡标题
        //this._levelTitle=new cc.LabelTTF(this.level+"、"+getWordByKey("title"),"SentyMaruko-02-SP",35,cc.size(winSize().width-100,winSize().height/2),cc.TEXT_ALIGNMENT_LEFT);
        this._levelTitle = createLabel(this.level + "、" + getConfigWordByKey("subject"), null, cc.color(255,255,255), cc.size(winSize().width - 100, winSize().height / 2), cc.TEXT_ALIGNMENT_LEFT);
        this._levelTitle.attr({
            anchorX: 0,
            anchorY: 1,
            x: 50,
            y: winSize().height - 150
        });
        this.addChild(this._levelTitle, 97);
    },
    getTitle: function () {
        return this._levelTitle;
    },
    hideTitle: function () {
        this.getTitle().visible = false;
    },
    showTitle: function () {
        this.getTitle().visible = true;
    },
    openAccelerometer: function () {
        var _this = this;
        this.closeAccelerometer();
        cc.inputManager.setAccelerometerInterval(1 / 30);
        cc.inputManager.setAccelerometerEnabled(true);
        this._accListener = this._accListener || cc.EventListener.create({
                event: cc.EventListener.ACCELERATION,
                callback: function (acc, event) {
                    if (_this.accCallback)
                        _this.accCallback(acc, event);
                }
            });
        cc.eventManager.addListener(this._accListener, this);
    },
    closeAccelerometer: function () {
        cc.inputManager.setAccelerometerEnabled(false);
        removeListener(this);
    },
    accCallback: function (acc, event) { //加速器回调
        var x = acc.x;
        var y = acc.y;
        var z = acc.z;

        if(isBrowser()) {
            trace("__加速计回调参数：[acc.x:" + x + "，acc.y:" + y + "，acc.z:" + z + "]__");
        }

        if(this.layer && typeof(this.layer.accCallback)==="function"){
            this.layer.accCallback(x,y,z);
        }
    }
});

var GameMenuLayer = cc.Layer.extend({
    size: null,
    keyBtn: null,
    tipsBtn: null,
    ctor: function () {
        this._super();
        this.size = cc.director.getWinSize();
        this.initSurface();
        return true;
    },
    initSurface: function () {
        var leftSpacing = 60;
        //var spacing = 180;

        // //金币按钮
        // var goldBtn=this.createBtnItem(getGoldNum(),"game_btn_gold",isHidePurchase==1?"game_hat":"game_btn_add");
        // goldBtn.attr({
        //     x:leftSpacing+spacing*0,
        //     y:this.size.height-50
        // });
        // this.addChild(goldBtn);
        // goldBtn.callback=function(){
        //
        // }.bind(this);
        // this.goldBtn=goldBtn;
        //
        // //提示按钮
        // var tipsBtn=this.createBtnItem("提示","game_btn_hint","game_hat");
        // tipsBtn.attr({
        //     x:leftSpacing+spacing*1,
        //     y:this.size.height-50
        // });
        // this.addChild(tipsBtn);
        // tipsBtn.callback=function(){
        //     this.pauseGame();
        //     var tipsLayer=new GameTipsLayer();
        //     tipsLayer.addToCurScene();
        // }.bind(this);
        // this.tipsBtn=tipsBtn;
        //
        // //跳过按钮
        // var passGold=100;
        // if(isMobile()){
        //     var onlinePassGold=getOnlineData("passGold");
        //     if(onlinePassGold && onlinePassGold!=""){
        //         passGold=parseInt(onlinePassGold);
        //     }
        // }
        // var passBtn=this.createBtnItem(passGold+"金币","game_btn_skip","game_hat");
        // passBtn.attr({
        //     x:leftSpacing+spacing*2,
        //     y:this.size.height-50
        // });
        // this.addChild(passBtn);
        // passBtn.callback=function(){
        //     if(consumeGold(passGold,false)){
        //         this.getParent().gameWin("",1);
        //     }else{
        //         //支付不成功处理
        //     }
        // }.bind(this);
        //
        // //暂停按钮
        // var pauseBtn=createButton({img:getResImg("game_btn_pause")});
        // pauseBtn.attr({
        //     x:this.size.width-50,
        //     y:this.size.height-50
        // });
        // this.addChild(pauseBtn);
        // pauseBtn.callback=function(){
        //     this.pauseGame();
        //     var pauseLayer=new PauseGameLayer();
        //     pauseLayer.addToCurScene();
        // }.bind(this);

        //菜单按钮
        var menuBtn = createButton({img: getResImg("guanq_btn_Level.png")});
        menuBtn.attr({
            x: leftSpacing,
            y: this.size.height - 65
        });
        this.addChild(menuBtn);
        menuBtn.callback = function () {
            removeLevelScenePlist(function () {
                try {
                    cc.director.runScene(new LevelSelectScene());
                } catch (err) {
                    _resumeGame();
                    cc.director.runScene(new LevelSelectScene());
                }

                //插屏广告
                // if (isMobile("Android")) {
                //     _selectCount++;
                //     if (adSelectHz > 0 && _selectCount % adSelectHz == 0) {
                //         CommonPlatform.getInstance().showInterstitialAd2();
                //     }
                //     trace("选关广告频率：" + adSelectHz + ", 当前次数：" + _selectCount % adSelectHz);
                // }
            });
        }.bind(this);

        //钥匙按钮
        var keyBtn = createButton("guanq_btn_key.png");
        keyBtn.attr({
            x: this.size.width / 2 - 35,
            y: this.size.height - 65
        });
        //keyBtn.setTag(9);
        this.addChild(keyBtn);
        keyBtn.callback = function () {
            var curScene=cc.director.getRunningScene();
            if(curScene.layer && curScene.layer.touchKeyCallback){
                curScene.layer.touchKeyCallback();
            }else {
                new StoreLayer().addToCurScene();
            }
        }.bind(this);

        //连接符号"x"
        var chaSprite = createSprite(getResImg("guanq_btn_Multiplied.png"));
        chaSprite.attr({
            x: keyBtn.width,
            y: keyBtn.height / 2 + 5
        });
        chaSprite.setScale(0.8);
        keyBtn.addChild(chaSprite);

        //钥匙数量
        var txtLabel = createLabel("" + getGoldNum(), 60,cc.color(0,0,0));
        txtLabel.attr({
            anchorX: 0,
            x: chaSprite.x + 5,
            y: chaSprite.y
        });
        //txtLabel.setTag(10);
        keyBtn.addChild(txtLabel);
        this.txtLabel = txtLabel;


        if(cc.director.getWinSize().width/cc.director.getWinSize().height < 0.53){
            keyBtn.x += 60;

        }

        //提示按钮
        var tipsBtn = createButton("guanq_btn_prompt.png");
        tipsBtn.attr({
            x: this.size.width - 70,
            y: this.size.height - 65
        });
        this.addChild(tipsBtn);
        tipsBtn.callback = function () {
            this.pauseGame();
            var tipsLayer = new GameTipsLayer();
            tipsLayer.addToCurScene();
        }.bind(this);


        if(isMobile("Android")){
            //跳过按钮
            var passBtn=createButton("guanq_tiaog.png");
            passBtn.attr({
                x:menuBtn.x+menuBtn.width/2+leftSpacing,
                y:menuBtn.y
            });
            this.addChild(passBtn);
            passBtn.callback=function(){
                new passLayer().addToCurScene();
            }.bind(this);
        }


        if(cc.director.getWinSize().width/cc.director.getWinSize().height < 0.53){
            menuBtn.scale = 0.75;
            menuBtn.y -= 15;
            keyBtn.scale = 0.75;
            keyBtn.y -= 15;
            txtLabel.scale = 0.75;
            txtLabel.y -= 15;
            tipsBtn.scale = 0.75;
            tipsBtn.y -= 15;
            if(isMobile("Android")){
                passBtn.scale = 0.75;
                passBtn.y -= 15;
            }
        }

    },
    pauseGame: function () {
        _pauseGame();
    },
    resumeGame: function () {
        _resumeGame();
    }
});
