/**
 * Created by weicheng on 15/10/6.
 *
 * 选关页面
 */

var LevelSelectLayer = cc.Layer.extend({
    size: null,
    maxLevel: 90,
    curPageIndex: 0,
    maxPageIndex: 6,
    curTouchX: 0,
    curMoveX: 0,
    scrollView: null,
    _points: [],
    click_flag: true,
    touch_flag: false,
    viewList:[],
    ctor: function () {
        this._super();
        this.size = cc.director.getWinSize();

        imgSearchPath="res_levelSelect";

        //展示插屏广告
        if (isShowGameSelectAd && (isReview!=1)){
            //展示选关广告位
            showAd("levelSelect");
        }
        isShowGameSelectAd = true;


        if (gameMaxLevel)this.maxLevel = gameMaxLevel;

        setIsReview();
        addLevelSpriteFrames();

        if (curMusicIndex != 1) {
            curMusicIndex = 1;
            stopMusic();
            playMusic(res_sound.brackgroundmusic_mp3, true);
        }

        var bg = createSprite(getResImg("Level_bg1.png", "res_levelSelect"));
        bg.attr({
            anchorY: 1,
            x: this.size.width / 2,
            y: this.size.height
        });
        this.addChild(bg);

        //装饰
         var man=createLevelSprite("Level_sxk.png");
        man.attr({
             anchorY:0,
             x:this.size.width/2+260,
             y:85
         });
         this.addChild(man,10);

        //返回按钮
        var returnBtn = createButton({img: getResImg("guanq_prompt_btn_return.png")});
        returnBtn.attr({
            x: 100,
            y: this.size.height - 130
        });
        this.addChild(returnBtn, 50);
        returnBtn.callback = function () {
            cc.director.runScene(new MainScene());
        };


        //商店按钮
        if(!isMobile("iOS")) {
            var storeBtn = createButton({img: getResImg("shangchang_btn_sahngchang", "res_store")});
            storeBtn.attr({
                x: this.size.width-100,
                y: this.size.height - 130
            });
            this.addChild(storeBtn, 10);
            storeBtn.callback = function () {
                new StoreLayer().addToCurScene();
            };
        }

        if(isMobile()){
            var isShowExchangeBtn=getOnlineData("isShowExchangeBtn");
            if((isMobile("iOS") && isReview!=1 && !!isShowExchangeBtn==true) || (isMobile("Android") && (getChannel()!="jidi"))){
                //兑换码
                var exchangeBtn=createButton({img:getResImg("btn_duihuangma","res_levelSelect")});
                exchangeBtn.attr({
                    x: this.size.width-100-storeBtn.width*1.2,
                    y: this.size.height - 130
                });
                this.addChild(exchangeBtn,50);
                exchangeBtn.callback=function(){
                    trace("兑换中心");
                    var exchangeLayer=new ExchangeLayer();
                    cc.director.getRunningScene().addChild(exchangeLayer,99);
                }
            }
        }

        //普通关卡页数
        this.maxPageIndex = Math.ceil(this.maxLevel / 15) || 0;

        //添加推荐应用页数
        if (recommendAppData) {
            var appPage = Math.ceil(recommendAppData.length / 6) || 0;
            this.maxPageIndex += appPage;
        }

        //关卡按钮列表
        this.createLevelList();


        //返回按键监听
        cc.eventManager.addListener({
            event: cc.EventListener.KEYBOARD,
            onKeyReleased: function (keyCode, event) {
                if (keyCode == 6) {
                    // cc.director.runScene(new MainScene());
                    CommonPlatform.getInstance().exit();
                }
            }
        }, this);

        return true;
    },
    createLevelList: function () {
        var scrollView = new ccui.ScrollView();
        scrollView.setDirection(ccui.ScrollView.DIR_HORIZONTAL);
        scrollView.setTouchEnabled(true);
        scrollView.setInertiaScrollEnabled(false);
        scrollView.setBounceEnabled(true);
        scrollView.setContentSize(cc.size(this.size.width, this.size.height));
        scrollView.setInnerContainerSize(cc.size(this.size.width * this.maxPageIndex, this.size.height));
        scrollView.addTouchEventListener(this.onTouchEvent, this);
        this.addChild(scrollView, 5);
        this.scrollView = scrollView;

        this.viewList=[];

        for (var i = 0; i < this.maxPageIndex; i++) {
            var view=new cc.Layer();
            view.x=this.size.width*i;
            view.visible=false;
            scrollView.addChild(view);
            this.viewList.push(view);

            var linkSpriteBatch=new cc.SpriteBatchNode(getResImg("Level_box_link.png"));
            view.addChild(linkSpriteBatch);

            if (i < (Math.ceil(this.maxLevel / 15) || 0)) {
                //游戏关卡
                for (var j = 0; j < 15; j++) {
                    var index = i * 15 + j + 1;

                    if (index > this.maxLevel)break;

                    var levelBtn = this.createLevelBtnItem(index);
                    levelBtn.attr({
                        x: this.size.width / 2 - 200 + j % 3 * 200,
                        y: this.size.height / 2 + 2.2 * 150 - Math.floor(j / 3) * 150 -20
                    });
                    view.addChild(levelBtn);


                    //线
                    if (index % 3 > 0 && index<this.maxLevel) {
                        var linkLabel = createSprite(getResImg("Level_box_link.png"));
                        linkLabel.attr({
                            anchorX: 0,
                            x: levelBtn.x + 70,
                            y: levelBtn.y
                        });
                        linkSpriteBatch.addChild(linkLabel);
                    }
                }
            } else {
                //游戏推荐
                for (var k = 0; k < 6; k++) {
                    var index = (i - 6) * 6 + k;
                    if (recommendAppData && index < recommendAppData.length) {
                        var recommendBtn = this.createRecommendItem(index);
                        recommendBtn.attr({
                            x: this.size.width / 2 - 135 + k % 2 * 270 ,
                            y: this.size.height / 2 + (k < 2 ? 220 : k < 4 ? 0 : -220)
                        });
                        view.addChild(recommendBtn);
                    } else {
                        break;
                    }
                }
            }
        }

        //当前页数
        this.curPageIndex = (Math.ceil((_preSelectLevel < 1 ? 1 : _preSelectLevel) / 15) - 1) % this.maxPageIndex;
        this.scrollView.getInnerContainer().runAction(cc.place(cc.p(-this.size.width * this.curPageIndex, 0)));
        this.createPoint();

    },
    createLevelBtnItem: function (level) {
        var levelBtn = createButton({img: getResImg("Level_box1", "res_levelSelect"), swallow: false, mode: 1});
        levelBtn.callback = function () {
             if(isAllLevelPassState!=1 && level>1 && getLevelStatusByLevel(level-1)!=1) {
                new LevelTipsLayer().addToCurScene();
             }else{
                 _preSelectLevel = level;
                 //初始化关卡文案
                 initLevelWordConfig(getClassName(level));
                 removeMainScenePlist(function () {
                    try {
                        cc.director.runScene(eval("new " + getClassName(level) + "()"));
                    } catch (err) {
                        trace("场景有错误（自动跳到测试页面）：" + err);
                        cc.director.runScene(new HelloWorldScene());
                    }
                 });
             }
        }.bind(this);


        // //关卡名字
        // var levelName=new cc.LabelTTF(levelConfig[level-1]["title"],"",24,cc.size(185,32),cc.TEXT_ALIGNMENT_CENTER);
        // levelName.attr({
        //     x:titleBg.width/2+16,
        //     y:titleBg.height/2-11,
        //     color:cc.color(232,193,101)
        // });
        // titleBg.addChild(levelName);
        //if (!isAllLevelPassState || isAllLevelPassState != 1) {
        //    if (level > 1 && getLevelStatusByLevel(level - 1) != 1) {
        //        //levelBtn.setTouchEnabled(false);
        //        //锁
        //        var lockLabel = createSprite(getResImg("Level_box_lock.png", "res_levelSelect"));
        //        lockLabel.attr({
        //            anchorX: 0,
        //            anchorY: 0,
        //            x: levelBtn.x + 20,
        //            y: levelBtn.y + 15
        //        });
        //        levelBtn.addChild(lockLabel);
        //    }
        //}
        var isLock=false;
        if (!isAllLevelPassState || isAllLevelPassState != 1) {
          if (level > 1 && getLevelStatusByLevel(level - 1) != 1) {
              isLock=true;

              //levelBtn.setTouchEnabled(false);
              //锁
              var lockLabel = createSprite(getResImg("Level_box_lock.png", "res_levelSelect"));
              lockLabel.attr({
                  anchorX: 0,
                  anchorY: 0,
                  x: levelBtn.x + 20,
                  y: levelBtn.y + 15
              });
              levelBtn.addChild(lockLabel);
          }
        }

        if(!isLock){
            //关卡数字
            var levelNum = createLabel(level, 60, cc.color(255, 255, 255));
            levelNum.attr({
                x: levelBtn.width / 2,
                y: levelBtn.height / 2
            });
            levelBtn.addChild(levelNum);
        }
        return levelBtn;
    },
    createRecommendItem: function (index) {    //应用推荐
        var recmdBtn = createButton({
            img: recommendAppData[index].iconUrl || getResImg("newgame_normal", "res_levelSelect"),
            swallow: false,
            mode: 1
        });
        recmdBtn.callback = function () {
            trace(recommendAppData[index].name);
            if (recommendAppData[index].state == 1) {
                trace("打开应用链接：" + recommendAppData[index].projectKey + "://");
                if (isMobile("Android")) {
                    CommonPlatform.getInstance().startAPP(recommendAppData[index].projectKey);
                } else {
                    CommonPlatform.getInstance().openUrl(recommendAppData[index].projectKey + "://", true);
                }
            } else if (recommendAppData[index].flag == 3) {

            } else {
                if (isMobile("Android")) {
                    CommonPlatform.getInstance().openUrl(recommendAppData[index].jumpUrl, true);
                } else {
                    CommonPlatform.getInstance().openUrl(recommendAppData[index].downloadUrl, true);
                }
            }
        };

        var gameState = "";
        var gameFlag;

        //标签
        if (recommendAppData[index].flag) {
            switch (parseInt(recommendAppData[index].flag)) {
                case 1:
                    gameFlag = createSprite(getResImg("newgame_new", "res_levelSelect"));
                    gameFlag.attr({
                        anchorY: 1,
                        x: isMobile("Android") ? 10 : recmdBtn.getBoundingBox().width - 40,
                        y: recmdBtn.getBoundingBox().height
                    });
                    recmdBtn.addChild(gameFlag);
                    break;
                case 2:
                    gameFlag = createSprite(getResImg("newgame_hot", "res_levelSelect"));
                    gameFlag.attr({
                        anchorY: 1,
                        x: isMobile("Android") ? 10 : recmdBtn.getBoundingBox().width - 40,
                        y: recmdBtn.getBoundingBox().height
                    });
                    recmdBtn.addChild(gameFlag);
                    break;
                case 3:
                    gameState = "即将上线";
                    break;
                default :
                    break;
            }
        }

        //状态
        if (recommendAppData[index].state) {
            switch (parseInt(recommendAppData[index].state)) {
                case -1:
                    gameState = "正在使用";
                    break;
                case 0:
                    gameState = "未安装";
                    break;
                case 1:
                    gameState = "立即体验";
                    break;
                default :
                    break;
            }
        }

        var appState = createLabel(gameState, 22);
        appState.attr({
            x: recmdBtn.width / 2,
            y: 43,
            color: cc.color(93, 69, 68)
        });
        recmdBtn.addChild(appState);


        return recmdBtn;
    },
    onTouchEvent: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                this.touch_flag = true;
                this.curTouchX = sender.getInnerContainer().getPositionX();
                this.curMoveX = 0;
                break;
            case ccui.Widget.TOUCH_MOVED:
                this.curMoveX = sender.getInnerContainer().getPositionX() - this.curTouchX;
                break;
            case ccui.Widget.TOUCH_ENDED:
            case ccui.Widget.TOUCH_CANCELED:
                if (this.touch_flag == true) {
                    this.touch_flag = false;
                    this.unscheduleAllCallbacks();
                    if (this.curMoveX != 0) {
                        if (this.curMoveX < -20) {
                            this.pageNext();
                        } else if (this.curMoveX > 20) {
                            this.pagePre();
                        } else {
                            this.scheduleOnce(function () {
                                sender.getInnerContainer().runAction(cc.moveTo(0.1, cc.p(-this.size.width * this.curPageIndex, 0)))
                            }, 0.1);
                        }
                    }
                }
                break;
            default:
                break;
        }
    },
    pageNext: function () {//菜单向左移动
        this.unscheduleAllCallbacks();
        if (this.curPageIndex < (this.maxPageIndex - 1)) {
            this.curPageIndex++;
            if (this.curPageIndex > (this.maxPageIndex - 1))this.curPageIndex = this.maxPageIndex - 1;
            this.scrollView.getInnerContainer().runAction(cc.moveTo(0.15, cc.p(-this.size.width * this.curPageIndex, 0)));
            this.runAction(cc.sequence(cc.delayTime(0.2), cc.callFunc(function () {
                this.click_flag = true;
            }, this)));
        } else {
            this.click_flag = true;
        }

        this.setPoint();
    },
    pagePre: function () {//菜单向右移动
        this.unscheduleAllCallbacks();
        if (this.curPageIndex > 0) {
            this.curPageIndex--;
            if (this.curPageIndex < 0)this.curPageIndex = 0;
            this.scrollView.getInnerContainer().runAction(cc.moveTo(0.15, cc.p(-this.size.width * this.curPageIndex, 0)));
            this.runAction(cc.sequence(cc.delayTime(0.2), cc.callFunc(function () {
                this.click_flag = true;
            }, this)));
        } else {
            this.click_flag = true;
        }

        this.setPoint();
    },
    showCurView:function(){//显示当前索引菜单栏（当前，前一个，后一个），隐藏非索引栏
        for(var i=0;i<this.viewList.length;i++){
            if(this.curPageIndex==i || this.curPageIndex-1==i || this.curPageIndex+1==i){
                this.viewList[i].visible=true;
            }else{
                this.viewList[i].visible=false;
            }
        }
    },
    createPoint: function () {//创建索引点
        this._points = [];
        for (var i = 0; i < this.maxPageIndex; i++) {
            var point = createSprite(getResImg("Level_Flip1.png", "res_levelSelect"));
            point.attr({
                x: this.size.width / 2 - (this.maxPageIndex / 2 - 0.5) * (point.width + 10) + i * (point.width + 10),
                y: 140
            });
            this.addChild(point, 2);
            this._points[i] = point;
        }
        this.setPoint();
    },
    setPoint: function () {//设置当前索引点
        this.showCurView();

        for (var i = 0; i < this._points.length; i++) {
            setSpriteTxture(this._points[i], getResImg("Level_Flip1.png", "res_levelSelect"));
        }
        setSpriteTxture(this._points[this.curPageIndex], getResImg("Level_Flip2.png", "res_levelSelect"));

        //设置游戏总时长
        setGameTime();
    }
});

var LevelSelectScene = cc.Scene.extend({
    ctor: function (level, callback) {
        this._super();
        cc.director.getRunningScene().cleanup();
        if (level)_preSelectLevel = level || 0;
        var layer = new LevelSelectLayer();
        this.addChild(layer);

        this.callback = callback;
    }, onEnter: function () {
        this._super();
        if (isMobile()) {
            CommonPlatform.getInstance().showBanner();
        }
        if(this.exchangeBtn)
            this.exchangeBtn.y+=60;


        removePlistCache();
        if (this.callback)this.callback();

        if (isMobile()) {
            CommonPlatform.getInstance().showVideoAlert();
        }
    }
});