/**
 * Created by weicheng on 15/10/6.
 *
 * 游戏主场景
 */

var MainSceneLayer = cc.Layer.extend({
    size: null,
    ctor: function () {
        this._super();
        this.size = cc.director.getWinSize();

        //修改imgSearchPath后，使用getResImg方法可免去添加搜索路径
        imgSearchPath="res_MainScene";

        setIsReview();

        if (isMobile()) {
            //游戏结束广告频率在线参数
            var onlineAdHz = getOnlineData("ad_insert_gameOver_hz");
            if (onlineAdHz && onlineAdHz != "" && !isNaN(onlineAdHz)) {
                adHz = onlineAdHz;
            }

            //关卡选择广告频率在线参数
            var onlineAdSelectHz = getOnlineData("ad_insert_select_hz");
            if (onlineAdSelectHz && onlineAdSelectHz != "" && !isNaN(onlineAdSelectHz)) {
                adSelectHz = onlineAdSelectHz;
            }

            if(isMobile("Android")){
                //关卡失败弹出商品购买窗口频率
                var onlineShowPurchaseHz=getOnlineData("show_purchase_hz");
                if(onlineShowPurchaseHz && onlineShowPurchaseHz!="" && !isNaN(onlineShowPurchaseHz)){
                    showPurchaseHz=onlineShowPurchaseHz;
                }
            }
        }

        if (curMusicIndex != 1) {
            curMusicIndex = 1;
            stopMusic();
            playMusic(res_sound.brackgroundmusic_mp3, true);
        }

        //设置游戏总时长
        setGameTime();

        //背景
        var bg = createSprite(getResImg("home_bg1.png", "res_MainScene"));
        bg.attr({
            anchorY: 0,
            x: winCenter().x,
            y: 0
        });
        this.addChild(bg);

        //云
        var cloud1=createLevelSprite("home_bg3.png");
        cloud1.attr({
            anchorY:0,
            anchorX:0,
            x:0,
            y:0
        });
        this.addChild(cloud1);

        //云2
        var cloud2=createLevelSprite("home_bg3.png");
        cloud2.attr({
            anchorY:0,
            anchorX:0,
            x:cloud1.width,
            y:cloud1.y
        });
        this.addChild(cloud2);

        //地面
        var ground1=createLevelSprite("home_bg2.png");
        ground1.attr({
            anchorY:0,
            anchorX:0,
            x:0,
            y:0
        });
        this.addChild(ground1);

        //地面2
        var ground2=createLevelSprite("home_bg2.png");
        ground2.attr({
            anchorY:0,
            anchorX:0,
            x:ground1.width,
            y:ground1.y
        });
        this.addChild(ground2);


        this.schedule(function(){
            ground1.x-=4;
            ground2.x-=4;

            if(ground1.x<=-ground1.width){
                ground1.x=0;
                ground2.x=ground1.width;
            }

            cloud1.x-=1;
            cloud2.x-=1;
            if(cloud1.x<=-cloud1.width){
                cloud1.x=0;
                cloud2.x=cloud1.width;
            }
        });

        //游戏忠告
        var zizhi=createLevelSprite("fn2_zizhi.png");
        zizhi.attr({
            x:winCenter().x,
            y:this.size.height - 60
        });
        zizhi.scale = 0.95;
        this.addChild(zizhi);



        //标题
        var title = createLevelSprite("title.png");
        title.attr({
            x: winCenter().x,
            y: this.size.height - 195
        });
        this.addChild(title);

        //坑爹男
        var man = createLevelSprite("home_Character_xiaokeng1.png", 0.1, [
            getResImg("home_Character_xiaokeng1.png", "res_MainScene"),
            getResImg("home_Character_xiaokeng2.png", "res_MainScene"),
            getResImg("home_Character_xiaokeng3.png", "res_MainScene"),
            getResImg("home_Character_xiaokeng4.png", "res_MainScene"),
            getResImg("home_Character_xiaokeng5.png", "res_MainScene"),
            getResImg("home_Character_xiaokeng6.png", "res_MainScene"),
            getResImg("home_Character_xiaokeng7.png", "res_MainScene"),
            getResImg("home_Character_xiaokeng8.png", "res_MainScene")
        ]);
        man.attr({
            x: winCenter().x,
            y: winCenter().y - 285
        });
        this.addChild(man);

        var dialog=createSprite(getResImg("home_Character_huakuang","res_MainScene"));
        dialog.attr({
            x:man.x-200,
            y:man.y+100
        });
        this.addChild(dialog);

        // //左小丑
        // var hezi=createLevelSprite("k_sy_hezi1.png",0.15,["k_sy_hezi1","k_sy_hezi2","k_sy_hezi1","k_sy_hezi2","k_sy_hezi3","k_sy_hezi4","k_sy_hezi3","k_sy_hezi4","k_sy_hezi3","k_sy_hezi4"]);
        // hezi.attr({x:winCenter().x+-152.5,y:winCenter().y+-351.9,scaleX:-1});
        // this.addChild(hezi);
        //
        // //右小丑
        // var hezi2=createLevelSprite("k_sy_hezi4.png",0.15,["k_sy_hezi4","k_sy_hezi3","k_sy_hezi4","k_sy_hezi3","k_sy_hezi4","k_sy_hezi3","k_sy_hezi2","k_sy_hezi1","k_sy_hezi2","k_sy_hezi1"]);
        // hezi2.attr({x:winCenter().x+159.0,y:winCenter().y+-358.5});
        // this.addChild(hezi2);
        //
        // //hahaha
        // var ha=createLevelSprite("k_sy_ha.png",0.2,["k_sy_ha2.png","k_sy_ha.png"]);
        // ha.attr({x:winCenter().x+-3.9,y:winCenter().y+-200});
        // this.addChild(ha);
        //
        // //play提示
        // var play=createSprite(getResImg("home_play","res_MainScene"));
        // play.attr({
        //     x:winCenter().x,
        //     y:winCenter().y+100
        // });
        // this.addChild(play);

        //开始按钮
        var starBtn = createButton({img: getResImg("home_btn_Start.png", "res_MainScene")});
        starBtn.attr({
            x: winCenter().x,
            y: winCenter().y + 90
        });
        this.addChild(starBtn);


        starBtn.callback = function () {
            //进入选关界面时赋值变量
            isShowGameSelectAd = false;
            playEffect(res_sound.click_mp3, 1);
            cc.director.runScene(new LevelSelectScene());
        };
        starBtn.runAction(cc.sequence(cc.scaleTo(0.4, 0.9), cc.scaleTo(0.4, 1)).repeatForever());

        if(cc.director.getWinSize().width/cc.director.getWinSize().height < 0.53){
            title.scale = 0.75
            zizhi.scale = 0.8;
            zizhi.y -= 10;
            starBtn.scale = 0.8;
            dialog.scale = 0.8;
        }

        starBtn.runAction(cc.sequence(cc.scaleTo(0.4, starBtn.scale-0.1), cc.scaleTo(0.4, starBtn.scale)).repeatForever());

        //点子征集按钮
        // if (!isHideOutChain()) {
        //     //投诉按钮
        //     if (isReview != 1) {
        //         var complaintBtn = createButton({img: getResImg("home_btn_01", "res_MainScene")});
        //         complaintBtn.attr({
        //             x: 100,
        //             y: 180
        //         });
        //         this.addChild(complaintBtn);
        //         complaintBtn.callback = function () {
        //             trace("投诉");
        //             if (isMobile()) {
        //                 CommonPlatform.getInstance().feedback();
        //             }
        //         };
        //     }
        // }

        // if(isWeb==0){
        //     //设置按钮
        //     var settingBtn=createButton({img:getResImg("home_btn_03","res_MainScene")});
        //     settingBtn.attr({
        //         x:winSize().width-100,
        //         y:250
        //     });
        //     this.addChild(settingBtn);
        //     settingBtn.callback=function(){
        //         new SettingLayer().addToCurScene();
        //     };
        // }

        //音乐开关按钮
        var musicOffBtn = createButton({img: getResImg(getMusicOffStatus() == "0" ? "setting_btn_Off_Volume.png" : "home_btn_volume.png", "res_MainScene")});
        musicOffBtn.attr({
            x: winSize().width - 80,
            y: 180
        });
        musicOffBtn.callback = function () {
            if (getMusicOffStatus() == "0") {
                setSoundOpenOrNot(true);
                setSpriteTxture(this, getResImg("home_btn_volume.png", "res_MainScene"));
            } else {
                setSoundOpenOrNot(false);
                setSpriteTxture(this, getResImg("setting_btn_Off_Volume.png", "res_MainScene"));
            }
        };
        this.addChild(musicOffBtn);


        //公告按钮
        try {
            if (isOpen("announcement")) {
                var noticeBtn = createButton({img: "home_btn_gg.png"});
                noticeBtn.attr({
                    x: 80,
                    y: 180
                });
                this.addChild(noticeBtn);
                noticeBtn.callback = function () {
                    // new CommunityLayer().addToCurScene();


                    isShowRedPoint=false;
                    if(redPoint){
                        redPoint.visible = false;
                    }
                    if(isMobile("Android")){
                        CommonPlatform.getInstance().openNotice();
                    }
                }
                if (getOnlineData("isShowRedPoint")=="true" && isShowRedPoint) {
                    var redPoint=createSprite(getResImg("redPoint.png","res_MainScene"));
                    redPoint.attr({
                        x: noticeBtn.width-15,
                        y: noticeBtn.height-15
                    });
                    noticeBtn.addChild(redPoint);
                }
            }
        }catch(e){}




        if(isMobile("iOS")) {
            //点赞按钮
            var likeBtn = createButton({img: getResImg("home_btn_like.png", "res_MainScene")});
            likeBtn.attr({
                x: musicOffBtn.x - 110,
                y: musicOffBtn.y
            });
            likeBtn.callback = function () {
                CommonPlatform.getInstance().directComment();
            };
            this.addChild(likeBtn);
        }else{
            //关于我们按钮
            if(getOnlineData("isShowAbout") == "true"&& (isReview!=1)){
            var aboutBtn = createButton({img: getResImg("btn_gth.png", "res_MainScene")});
            aboutBtn.attr({
                x: musicOffBtn.x - 110,
                y: musicOffBtn.y
            });
            aboutBtn.callback = function () {
                new disclaimerLayer().addToCurScene();
            };
            this.addChild(aboutBtn);
            }
        }

        //更多游戏按钮
         // if (isOpen("gameMore")|| getChannel() == "play") {
         //     //更多游戏按钮
         //     var moreBtn = createButton({img: getResImg("tguang_btn_gdyx", "res_Panel")});
         //     moreBtn.attr({
         //         x: 80,
         //         y: cc.director.getWinSize().height/1.5
         //     });
         //     this.addChild(moreBtn);
         //     moreBtn.callback = function () {
         //         trace("更多游戏");
         //         CommonPlatform.getInstance().moreGame();
         //     };
         // }

        var moreBtn = createButton({img: getResImg("tguang_btn_gdyx", "res_Panel")});
        moreBtn.attr({
            x: 80,
            y: cc.director.getWinSize().height/1.5,
            visible:false
        });
        this.addChild(moreBtn);
        moreBtn.callback = function () {
            trace("更多游戏");
            CommonPlatform.getInstance().moreGame();
        };

        if(isOpen("gameMore") || getChannel() == "play") {
            moreBtn.visible=true;
        }

        //小游戏按钮
        var overLevelLittleGame=getOnlineData("overLevelLittleGame") || 4;
        if (isOpen("littleGame") && getLevelPassNum()>=overLevelLittleGame) {
            //小游戏按钮
            var littleGameBtn = createButton({img: getResImg("littlegame")});
            littleGameBtn.attr({
                x: winSize().width - 80,
                y: cc.director.getWinSize().height/1.5
            });
            littleGameBtn.scale = 1.5;
            this.addChild(littleGameBtn);
            littleGameBtn.callback = function () {
                trace("小游戏按钮");
                CommonPlatform.getInstance().openLittleGame();
            };
        }

        //返回按键监听
        cc.eventManager.addListener({
            event: cc.EventListener.KEYBOARD,
            onKeyReleased: function (keyCode, event) {
                if (keyCode == 6) {
                    trace("调用退出");
                    CommonPlatform.getInstance().exit();
                }
            }
        }, this);


        return true;
    },
    onEnter: function () {
        this._super();
        //首次打开加100金币
        if (isWeb == 0 && !getIsFirstOpen()) {
            //addGoldNum(100,true);
            setIsFirstOpen();
        }
        if (isMobile()) {
            CommonPlatform.getInstance().removeBanner();
        }
    }
});

var MainScene = cc.Scene.extend({
    ctor: function () {
        this._super();
        cc.director.getRunningScene().cleanup();
        removePlistCache();
        var layer = new MainSceneLayer();
        this.addChild(layer);
    }
});