/**
 * Created by weicheng on 15/10/6.
 *
 * 游戏预加载场景
 */

var ReadyLayer = cc.Layer.extend({
    loserNames: [],
    ctor: function (level) {
        this._super();
        var size = cc.director.getWinSize();
        var _this = this;

        //设置游戏总时长
        setGameTime();

        setIsReview();

        if (isWeb != 1) {
            if (curMusicIndex == 0) {
                curMusicIndex = 1;
                stopMusic();
                playMusic(res_sound.brackgroundmusic_mp3, true);
            }
        }

        //初始化关卡文案
        initLevelWordConfig(getClassName(level));

        //添加关卡资源
        addLevelSpriteFrames(getClassName(level));

        var bg = createSprite(getResImg("guanq_bg1.png"));
        bg.attr({
            anchorY: 1,
            x: size.width / 2,
            y: size.height
        });
        this.addChild(bg);

        //返回按钮
        if (isWeb == 1 && isBrowser() && isWebTest != 1) {
        }
        else {
            var returnBtn = createButton({img: getResImg("guanq_prompt_btn_return.png")});
            returnBtn.attr({
                x: 100,
                y: size.height - 130
            });
            this.addChild(returnBtn, 10);
            returnBtn.callback = function () {
                removeLevelScenePlist(function () {
                    try {
                        cc.director.runScene(new LevelSelectScene());
                    } catch (err) {
                        _resumeGame();
                        cc.director.runScene(new LevelSelectScene());
                    }
                });
            }
        }

        //外框
        var frame = createSprite(getResImg("guanq_kaiw_jse2.png"));
        frame.attr({
            x: size.width / 2,
            y: size.height / 2 + 90
        });
        this.addChild(frame);

        //标题
        var title = createLabel(level + "、" + levelConfig[level - 1]["title"], 40);
        title.attr({
            x: frame.width / 2,
            y: frame.height - 85
        });
        frame.addChild(title);

        //关卡图
        // var icon=createSprite(getResImg("icon_"+levelConfig[level-1]["className"],"res_levelIcon"));
        // icon.attr({
        //     x:frame.width/2,
        //     y:frame.height/2+67
        // });
        // frame.addChild(icon);

        //关卡描述
        var desc = createLabel(levelConfig[level - 1]["desc"].replace(/{n}/g, "\n"), 30, null, cc.size(380, 120), cc.TEXT_ALIGNMENT_CENTER);
        desc.attr({
            anchorY: 1,
            x: frame.width / 2,
            y: 220
        });
        frame.addChild(desc);

        //开始按钮
        var startBtn = createButton({img: getResImg("guanq_kaiw_jse1.png")});
        startBtn.attr({
            x: size.width / 2,
            y: size.height / 2 - 260
        });
        this.addChild(startBtn);

        var startGame = function () {
            removeMainScenePlist(function () {
                try {
                    cc.director.runScene(eval("new " + getClassName(level) + "()"));
                } catch (err) {
                    trace("场景有错误（自动跳到测试页面）：" + err);
                    cc.director.runScene(new HelloWorldScene());
                }
            });
        };

        startBtn.callback = startGame;

        if (isBrowser()) {
            share(1002);
        }

        // if (isBrowser() && isTestMode == 1) {
        //     var levelNameLabel = new cc.LabelTTF("关卡类名：\n" + getClassName(level), "SentyMaruko-02-SP", 24, null, cc.TEXT_ALIGNMENT_CENTER);
        //     levelNameLabel.attr({
        //         anchorY: 1,
        //         x: size.width / 2,
        //         y: size.height - 30,
        //         //color:cc.color(0,0,0),
        //         lineWidth: 3,
        //         strokeStyle: cc.color(0, 0, 0)
        //     });
        //     this.addChild(levelNameLabel);
        // }


        //返回按键监听
        cc.eventManager.addListener({
            event: cc.EventListener.KEYBOARD,
            onKeyReleased: function (keyCode, event) {
                if (keyCode == 6) {
                    // cc.director.runScene(new MainScene());
                    CommonPlatform.getInstance().exit();
                }
            }
        }, this);

    }
});

var ReadyScene = cc.Scene.extend({
    callback: null,
    ctor: function (level, callback) {
        this._super();
        cc.director.getRunningScene().cleanup();
        removePlistCache();
        if (level)_preSelectLevel = level;
        this.addChild(new ReadyLayer(_preSelectLevel));
        if (callback)this.callback = callback;
    }, onEnter: function () {
        this._super();
        if (isMobile("iOS")) {
            CommonPlatform.getInstance().showBanner();
        }
        if (this.callback)this.callback();
    },
    onExit: function () {
        this._super();
        if (isMobile("iOS")) {
            CommonPlatform.getInstance().removeBanner();
        }
    }
});