/**
 * Created by weicheng on 15/10/6.
 *
 * 网页版游戏场景类
 */
isWeb = 1;    //当前为网页版,1:单关版，2:三关版
isWebTest = 0;//关闭网页测试

if (isWeb == 2) {
    gameMaxLevel = 4;
}

var GameSceneBase = cc.Scene.extend({
    level: 1, //当前关卡序号
    _className: "GameSceneBase",
    _menuLayer: null,    //菜单栏
    _bgFile: null,
    state: 0, //场景状态、0：游戏中，1：胜利，2：失败
    ctor: function () {
        this._super();
        //音效清除
        effectArray = [];

        var _this = this;

        this.level = _preSelectLevel || 1;
        this._className = getClassName(this.level);
        this.size = cc.director.getWinSize();
        this.initSurface();

        stopAllEffect();
        stopMusic();

        this.state = 0;

        curMusicIndex = 2;
        try {
            playMusic(res_sound.brackgroundmusic_mp3, true);
        } catch (err) {
            trace("背景音乐找不到：" + err);
        }

        //设置游戏总时长
        setGameTime();

        cc.eventManager.addCustomListener(cc.game.EVENT_HIDE, function () {
            if (_this.state == 0) {
                _this.pauseTheGame();
            }
        });
        cc.eventManager.addCustomListener(cc.game.EVENT_SHOW, function () {
            if (_this.state == 0) {
                _this.resumeTheGame();
            }
        });


        return true;
    },
    onEnter: function () {
        this._super();
        //设备背景图片
//        addBackground(this._bgFile, this);
        addBackground(this._bgFile, this);//设备背景图片
    },
    pauseTheGame: function () {
        trace("暂停游戏处理");
    },
    resumeTheGame: function () {
        trace("恢复游戏处理");
    },
    gameWrong: function (x, y, z) {
        var layer = new duicuoLayer(x, y, z);
        this.addChild(layer, 99);
    },
    gameRight: function (x, y, z, a) {
        var layer = new duiLayer(x, y, z, a);
        this.addChild(layer, 99);
    },
    showGameWin: function () {
        this.gameWin();
    },
    showGameOver: function () {
        this.gameOver();
    },
    gameOver: function (faileKey, lossType) {
        faileKey = faileKey || "lossWord1";

        this.gameOverCallBack(faileKey);
    },
    gameWin: function (winWordKey, winType) {

        this.gameWinCallBack(winWordKey, winType);
    },
    gameOverCallBack: function (faileKey) { //faileKey:文案键名（对应失败文案）
        _pauseGame();
        this.unAllSchedule();

        this.rotation = 0;
        this.state = 2;

        //设置游戏总时长
        setGameTime();

        //添加死亡次数
        addLossCount();

        playEffect(res_sound.faile_mp3);

        var layer = new PanelViewBase();
        this.addChild(layer, 99);

        var frame = createSprite(getResImg("guanq_shibaiyemian.png", "res_GameOver"));
        layer.nodeUI_.addChild(frame);

        //失败文案
        var faileWordLabel = createLabel(getWordByKey(faileKey), 30, cc.color(255, 255, 255), cc.size(355, 155), cc.TEXT_ALIGNMENT_CENTER, cc.VERTICAL_TEXT_ALIGNMENT_CENTER);
        faileWordLabel.attr({
            x: frame.width / 2 + 30,
            y: frame.height / 2 + 100
        });
        frame.addChild(faileWordLabel);

        if (isWeb == 2) {
            //返回菜单按钮
            var exitBtn = createButton({img: getResImg("guanq_btn_Level.png", "res_GameOver")});
            exitBtn.attr({
                x: frame.width / 2 - 20,
                y: frame.height / 2 - 50
            });
            frame.addChild(exitBtn);
            exitBtn.callback = function () {
                stopAllEffect();
                removeLevelScenePlist(function () {
                    cc.director.runScene(new LevelSelectScene());
                });
            }.bind(this);
        } else {
            //更多关卡按钮
            var moreBtn = createButton({img: getResImg("guanq_btn_genduoguanqia.png", "res_webCommon")});
            moreBtn.attr({
                x: frame.width / 2 - 20,
                y: frame.height / 2 - 50
            });
            frame.addChild(moreBtn);
            moreBtn.callback = function () {
                trace("更多关卡");
                new DownloadTipsLayer(function () {
                }).addToCurScene();
            }.bind(this);
        }

        //重来按钮
        var againBtn = createButton({img: getResImg("guanq_btn_sxin.png", "res_GameOver")});
        againBtn.attr({
            x: frame.width / 2 + 80,
            y: frame.height / 2 - 50
        });
        frame.addChild(againBtn);
        againBtn.callback = function () {
            _resumeGame();
            cc.director.runScene(eval("new " + getClassName(this.level) + "()"));
        }.bind(this);

        //求助按钮
        var helpBtn = createButton({img: getResImg("guanq_btn_qiuz.png", "res_GameOver")});
        helpBtn.attr({
            x: frame.width / 2 + 180,
            y: frame.height / 2 - 50
        });
        frame.addChild(helpBtn);
        helpBtn.callback = function () {
            trace("求助");
            __shareTips.show();
        }.bind(this);

        share("这游戏有毒求助：" + levelConfig[_preSelectLevel - 1]["helpWord"], "http://h5.kdyx.cn/" + gameKey, 1002);

    },
    gameWinCallBack: function (winWordKey, winType) {
        _pauseGame();
        this.unAllSchedule();

        //设置游戏总时长
        setGameTime();

        this.rotation = 0;
        this.state = 1;

        playEffect(res_sound.win_wav);

        winWordKey = winWordKey || "winWord";

        if (getLevelStatusByLevel(this.level) != 1) {
            //修改关卡通关状态
            setLevelStatusByLevel(this.level, 1);
        }

        var layer = new PanelViewBase();
        this.addChild(layer, 99);

        var frame = createSprite(getResImg("guanq_sliyemian.png", "res_GameOver"));
        layer.nodeUI_.addChild(frame);

        //通关文案
        var winWordLabel = createLabel(winType != 1 ? getWordByKey(winWordKey) : "鄙视用金币过关的人！", 30, cc.color(255, 255, 255), cc.size(355, 155), cc.TEXT_ALIGNMENT_CENTER, cc.VERTICAL_TEXT_ALIGNMENT_CENTER);
        winWordLabel.attr({
            x: frame.width / 2 + 50,
            y: frame.height / 2 + 100
        });
        frame.addChild(winWordLabel);

        //重来按钮
        var againBtn = createButton({img: getResImg("guanq_btn_sxin.png", "res_GameOver")});
        againBtn.attr({
            x: frame.width / 2,
            y: frame.height / 2 - 50
        });
        frame.addChild(againBtn);
        againBtn.callback = function () {
            try {
                _resumeGame();
                cc.director.runScene(eval("new " + getClassName(this.level) + "()"));
            } catch (err) {
            }
        }.bind(this);

        //下一关按钮
        var nextBtn = createButton({img: getResImg("guanq_btn_xiaxiang.png", "res_GameOver")});
        nextBtn.attr({
            x: frame.width / 2 + 100,
            y: frame.height / 2 - 50
        });
        frame.addChild(nextBtn);
        nextBtn.callback = function () {
            if (isWeb == 2 && this.level < gameMaxLevel - 1) {
                _resumeGame();
                cc.director.runScene(new ReadyScene(this.level + 1));
            } else {
                trace("下载完整版");
                new DownloadTipsLayer(function () {
                }).addToCurScene();
            }
        }.bind(this);

        //炫耀按钮
        var shareBtn = createButton({img: getResImg("guanq_btn_xyao.png", "res_GameOver")});
        shareBtn.attr({
            x: frame.width / 2 + 200,
            y: frame.height / 2 - 50
        });
        frame.addChild(shareBtn);
        shareBtn.callback = function () {
            trace("炫耀");
            __shareTips.show();
        }.bind(this);

        share("这游戏有毒：" + levelConfig[_preSelectLevel - 1]["winShareWord"], "http://h5.kdyx.cn/" + gameKey, 1003);
    },
    unAllSchedule: function () {
        for (var i = 0; i < this.getChildren().length; i++) {
            this.getChildren()[i].unscheduleAllCallbacks();
        }
    },
    throwSkill: function () {
        trace("抛手机技能");
    },
    shakeSkill: function () {
        trace("摇一摇技能");
    },
    filpSkill: function () {
        trace("90翻转手机技能");
    },
    filpSkill1: function () {
        trace("180翻转手机技能");
    },
    filpSkill2: function () {
        trace("270翻转手机技能");
    },
    hideMenuGoldBtn: function () { //隐藏金币按钮
        this._menuLayer.goldBtn.visible = false;
    },
    showMenuGoldBtn: function () { //隐藏金币按钮
        this._menuLayer.goldBtn.visible = true;
    },
    hideMenuTipsBtn: function () { //隐藏提示按钮
        this._menuLayer.tipsBtn.visible = false;
    },
    showMenuTipsBtn: function () { //显示提示按钮
        this._menuLayer.tipsBtn.visible = true;
    },
    initSurface: function () {
        this._menuLayer = new GameMenuLayer();
        this.addChild(this._menuLayer, 98);

        //关卡标题
        this._levelTitle = createLabel(this.level + "、" + getWordByKey("title"), null, null, cc.size(winSize().width - 100, winSize().height / 2), cc.TEXT_ALIGNMENT_LEFT);
        this._levelTitle.attr({
            anchorX: 0,
            anchorY: 1,
            x: 50,
            y: winSize().height - 130
        });
        this.addChild(this._levelTitle, 97);
    },
    getTitle: function () {
        return this._levelTitle;
    },
    hideTitle: function () {
        this.getTitle().visible = false;
    },
    showTitle: function () {
        this.getTitle().visible = true;
    },
    openAccelerometer: function () {
        var _this = this;
        this.closeAccelerometer();
        cc.inputManager.setAccelerometerInterval(1 / 30);
        cc.inputManager.setAccelerometerEnabled(true);
        this._accListener = this._accListener || cc.EventListener.create({
                event: cc.EventListener.ACCELERATION,
                callback: function (acc, event) {
                    if (_this.accCallback)
                        _this.accCallback(acc, event);
                }
            });
        cc.eventManager.addListener(this._accListener, this);
    },
    closeAccelerometer: function () {
        cc.inputManager.setAccelerometerEnabled(false);
        removeListener(this);
    },
    accCallback: function (acc, event) { //加速器回调
        var x = acc.x;
        var y = acc.y;
        var z = acc.z;
        cc.log("__加速计回调参数：[acc.x:" + x + "，acc.y:" + y + "，acc.z:" + z + "]__");
    }
});

var GameMenuLayer = cc.Layer.extend({
    size: null,
    goldBtn: null,
    tipsBtn: null,
    kengBB: null,
    ctor: function () {
        this._super();
        this.size = cc.director.getWinSize();
        this.initSurface();
        return true;
    },
    initSurface: function () {
        var leftSpacing = 90;


        ////菜单按钮
        //var menuBtn = createButton({img: getResImg("guanq_btn_Level.png")});
        //menuBtn.attr({
        //    x: leftSpacing,
        //    y: this.size.height - 80
        //});
        //this.addChild(menuBtn);
        //menuBtn.callback = function () {
        //    removeLevelScenePlist(function () {
        //        try {
        //            cc.director.runScene(new LevelSelectScene());
        //        } catch (err) {
        //            _resumeGame();
        //            cc.director.runScene(new LevelSelectScene());
        //        }
        //    });
        //}.bind(this);

        ////钥匙按钮
        //var keyBtn = createButton("guanq_btn_key.png");
        //keyBtn.attr({
        //    x: this.size.width / 2 - 25,
        //    y: this.size.height - 80
        //});
        ////keyBtn.setTag(9);
        //this.addChild(keyBtn);
        //keyBtn.callback = function () {
        //
        //}.bind(this);
        //
        ////连接符号"x"
        //var chaSprite = createSprite(getResImg("guanq_btn_Multiplied.png"));
        //chaSprite.attr({
        //    x: keyBtn.width,
        //    y: keyBtn.height / 2 + 5
        //});
        //chaSprite.setScale(0.8);
        //keyBtn.addChild(chaSprite);
        //
        ////钥匙数量
        //var txtLabel = createLabel("" + getGoldNum(), 60);
        //txtLabel.attr({
        //    anchorX: 0,
        //    x: chaSprite.x + 15,
        //    y: chaSprite.y
        //});
        ////txtLabel.setTag(10);
        //keyBtn.addChild(txtLabel);
        //this.txtLabel = txtLabel;

        //提示按钮
        var tipsBtn = createButton("guanq_btn_prompt.png");
        tipsBtn.attr({
            x: this.size.width - 70,
            y: this.size.height - 80
        });
        this.addChild(tipsBtn);
        tipsBtn.callback = function () {
            this.pauseGame();
            var tipsLayer = new GameTipsLayer();
            tipsLayer.addToCurScene();
        }.bind(this);


        //技能按钮
        this.skillBtn = createButton({img: getLevelImg("guanq_btn_jin.png")});
        this.skillBtn.attr({
            x: 65,
            y: 150
        });
        this.addChild(this.skillBtn, 10);
        this.skillBtn.callback = function () {
            this.showSkillBtn();
        }.bind(this);

        //创建按钮列表
        this.createSkillBtn();
    },
    createSkillBtn: function () {
        this.skillArr = [];

        var node = new cc.Node();
        node.attr({
            x: this.skillBtn.x,
            y: this.skillBtn.y
        });
        this.addChild(node, 9);

        var rotation = 0;

        //翻转
        var flipBtn = createButton({img: getLevelImg("guanq_btn_fanzhuanshouji.png")});
        flipBtn.attr({
            opacity: 0
        });
        node.addChild(flipBtn);
        flipBtn.callback = function () {
            var curScene = cc.director.getRunningScene();
            //if (rotation == 0) {
            //    rotation = -90;
            //}else if( rotation == -90){
            //    rotation = -180;
            //    this.getParent().filpSkill1();
            //}
            //else if( rotation == -180){
            //    rotation = -270;
            //    this.getParent().filpSkill2();
            //}
            //else {
            //    rotation = 0;
            //}
            //curScene.rotation = rotation;
            //this.getParent().filpSkill();
            switch (rotation){
                case 0:
                    rotation=-90;
                    this.getParent().filpSkill();
                    break;
                case -90:
                    rotation=-180;
                    this.getParent().filpSkill1();
                    break;
                case -180:
                    rotation=-270;
                    this.getParent().filpSkill1=function(){};
                    this.getParent().filpSkill2();
                    break;
                default:
                    rotation=0;
                    break;
            }
            curScene.rotation = rotation;
        }.bind(this);
        this.skillArr[2] = flipBtn;

        //摇
        var shakeBtn = createButton({img: getLevelImg("guanq_btn_yaoshouji.png")});
        shakeBtn.attr({
            opacity: 0
        });
        node.addChild(shakeBtn);
        shakeBtn.callback = function () {
            var curScene = cc.director.getRunningScene();
            curScene.runAction(cc.sequence(
                cc.rotateTo(0.05, rotation - 2),
                cc.rotateTo(0.05, rotation + 0),
                cc.rotateTo(0.05, rotation + 2),
                cc.rotateTo(0.05, rotation + 0)
            ));
            this.getParent().shakeSkill();
        }.bind(this);
        this.skillArr[1] = shakeBtn;

        ////抛
        var throwBtn = createButton({img: getLevelImg("guanq_btn_daokshouji.png")});
        throwBtn.attr({
            opacity: 0
        });
        node.addChild(throwBtn);
        throwBtn.callback = function () {
            var curScene = cc.director.getRunningScene();
            curScene.runAction(cc.sequence(
                cc.scaleTo(0.05, 1.02),
                cc.scaleTo(0.05, 1)
            ));
            this.getParent().throwSkill();
        }.bind(this);
        this.skillArr[0] = throwBtn;
    },
    showSkillBtn: function () {
        for (var i = 0; i < this.skillArr.length; i++) {
            var skill = this.skillArr[i];
            skill.stopAllActions();
            if (!this.skillOff) {
                var velocity = cc.pMult(cc.pForAngle(i * 0.9 - 0.2), 130);
                skill.runAction(cc.spawn(
                    cc.moveTo(0.3, velocity),
                    cc.rotateTo(0.3, 720),
                    cc.fadeIn(0.3)
                ));
                skill.setTouchEnabled(true);
            } else {
                skill.runAction(cc.sequence(
                    cc.spawn(
                        cc.moveTo(0.3, cc.p(0, 0)),
                        cc.rotateTo(0.3, -720),
                        cc.fadeOut(0.3)
                    )
                ));
                skill.setTouchEnabled(false);
            }
        }

        this.skillOff = !this.skillOff;
    },
    pauseGame: function () {
        _pauseGame();
    },
    resumeGame: function () {
        _resumeGame();
    }
});
