/**
 * Created by weicheng on 15/10/7.
 *
 *数据
 */
var gameKey = "touble2";
var localStorageKey = {
    KEY_GOLD_STR: gameKey + "key_gold_str",
    KEY_LEVEL_STATUS_STR: gameKey + "key_level_status_str",
    KEY_MUSIC_OFF_STATUS_STR: gameKey + "key_music_off_status_str",
    KEY_IS_FIRST_OPEN: gameKey + "key_is_first_open",
    KEY_SELECT_LEVEL:gameKey+"key_select_level",
    KEY_LEVEL_TIPS_LOCK_STATUS_STR: gameKey + "key_level_tips_lock_status_str",
    KEY_LOSS_COUNT_STR: gameKey + "key_loss_count_str",
    KEY_TIME_STR: gameKey + "key_time_str",
    KEY_IS_LEVEL_ALL_PASS: gameKey + "key_is_level_all_pass",
    KEY_EXCHANGE_STR: gameKey + "key_exchange_str",
    KEY_IS_BUY_NOVICE_PACKAGE: gameKey + "key_is_buy_novice_package",
    KEY_IS_BUY_MASTER_PACKAGE: gameKey + "key_is_buy_master_package",
    KEY_IS_BUY_STRATEGY: gameKey + "key_is_buy_strategy",
    KEY_MY_NAME: gameKey + "key_my_name",
    KEY_HISTORY_LOSER_NAME: gameKey + "key_history_loser_name",
    KEY_IS_RESET_NAME: gameKey + "key_is_reset_name"
};

var curMusicIndex = 0;        //当前音乐索引，主场景音乐：1，关卡音乐：2
var isReview = 1;             //审核开关
var openTime = getCurTime();  //打开游戏时间
var levelSpriteFrames = [];   //关卡精灵缓存列表
var recommendAppData;       //推荐应用数据
var levelConfig = [];         //关卡配置
var levelWordConfig = {};     //关卡文案配置
var _preSelectLevel = 1;      //当前准备关卡序号
var isShieldGdt = 1;          //失败插屏屏蔽广点通广告
var adHz = 3;                 //广告频率
var _faileCount = 0;          //失败次数
var _winCount = 0;             //胜利次数
var adSelectHz = 3;           //选关广告频率
var _selectCount = 0;         //去到选关页面次数
var isLoading = 0;            //是否在loading界面
var sceneType = 0;            //当前场景类型，主场景：0，关卡：1
var isWeb = 0;                //当前是否为网页版
var isWebTest = 1;            //网页关卡测试
var isAllLevelPassState = 0;  //开启全关卡（发布的时候需要调为0）
var gameMaxLevel = 90;        //游戏最大关卡数量
var isFree = 0;               //免支付模式
var isALLGameWeb = 0;         //是否为Web全关卡版
var videoDownTime = {};       //视频按钮倒计时
videoDownTime.surplusTime = 0;         //剩余时间
videoDownTime.openTime = getCurTime();   //开始倒计时时间
var isTestMode = 0;           //调试模式（发布的时候需要调为0）
var showPackageHz = 2;        //关卡结束显示礼包窗口频率
var showPurchaseHz = 3;       //关卡失败显示购买窗口频率
var isHidePurchase = 0;       //隐藏计费点
var touchBtnList = [];        //按钮列表
var imgSearchPath=null;       //添加图片搜索路径
var isShowRedPoint=true ;
var isShowGameSelectAd=false;      //是否在选关页面弹出插屏广告
var curWindow;
var _onlineDataList={};
function saveData(key, value) {
    key = value ? base64encode("" + key) : "";
    value = value ? base64encode("" + value) : "";
    cc.sys.localStorage.setItem(key, value);
}

// 测试模式
// if(true){
//     isAllLevelPassState=1;
//     isTestMode=1;
// }

function getData(key) {
    key = key ? base64encode("" + key) : "";
    var value = cc.sys.localStorage.getItem(key);
    value = value ? base64decode(value) : null;
    return value;
}

function initLevelConfig() {
    try {
        cc.loader.loadTxt("res/levelConfig.csv", function (err, data) {
            if (err) {
                trace(err);
                return;
            }

            var csvArray = CSVToArray(data, ",");
            var arr = [];
            for (var i = 2; i <= csvArray.length - 1; i++) {
                var levelData = {};
                for (var j = 0; j < csvArray[i].length; j++) {
                    levelData[csvArray[1][j]] = csvArray[i][j];
                }
                arr.push(levelData);
            }
            levelConfig = arr;
        });
    } catch (err) {
        trace("获取关卡配置总表错误：" + err);
    }
}

//初始化对应关卡的文案csv数据
function initLevelWordConfig(levelClassName) {
    try {
        cc.loader.loadTxt("res/levels/" + levelClassName + "/config.csv", function (err, data) {
            if (err) {
                trace(err);
                levelWordConfig = {};
                return;
            }
            var csvArray = CSVToArray(data, ",");
            var json = {};
            for (var i = 2; i < csvArray.length; i++) {
                if (csvArray[i][0] != "") {
                    json[csvArray[i][0]] = csvArray[i][2];
                }
            }
            levelWordConfig = json;
            trace(levelWordConfig);
        });
    } catch (err) {
        trace("获取关卡文案配置表错误：" + err);
    }
}

//获取对应关卡编号的关卡名字
function getClassName(levelNum) {
    var className = "HelloWorldScene";
    try {
        className = levelConfig[parseInt(levelNum) - 1]["className"];
    } catch (err) {
        className = "HelloWorldScene";
        trace("获取关卡类名错误：" + err);
    }
    return className;
}

//获取对应关卡名字的关卡编号
function getLevelNum(className) {
    var levelNum = 0;
    for (var i = 0; i < levelConfig.length; i++) {
        if (levelConfig[i]["className"] == className) {
            levelNum = levelConfig[i]["level"];
            break;
        }
    }
    return levelNum;
}

//获取关卡配置表对应键值的文案
function getWordByKey(key) {
    if (!key)return "请输入对应文案的键值";
    var Word = "";
    Word = levelWordConfig[key];
    if (Word)Word = Word.replace(/{n}/g, "\n");
    return Word || key + ":无文案";
}

//获取总配置表当前关卡对应键值文案
function getConfigWordByKey(key){
    if (!key)return "请输入对应文案的键值";
    var Word = "";
    Word = levelConfig[parseInt(_preSelectLevel - 1)][key];
    return Word || key + ":无文案";
}

//获取对应关卡编号的提示文案
function getTipsWord(level, num) {
    if (!level)return "请输入提示关卡的编号";
    var tipsWord = "";
    tipsWord = levelConfig[parseInt(level - 1)]["tips" + (num || 1)];
    if (tipsWord)tipsWord = tipsWord.replace(/{n}/g, "\n");
    return tipsWord || "无提示文案";
}

//获取所有关卡通关状态
function getLevelsStatus() {
    var levelsStatus = getData(localStorageKey.KEY_LEVEL_STATUS_STR);
    if (levelsStatus == null || levelsStatus == "") {
        levelsStatus = "";
        for (var i = 1; i <= gameMaxLevel; i++) {
            levelsStatus += i == gameMaxLevel ? "0" : "0-";
        }
    }
    return levelsStatus.split("-");
}

//获取关卡通关数量
function getLevelPassNum(){
    var levelStatus=getLevelsStatus();
    var passLevel=0;
    for(var i=0;i<levelStatus.length;i++){
        if(levelStatus[i]==1){
            passLevel++;
        }else{
            break;
        }
    }
    return passLevel;
}

//获取关卡通关状态
function getLevelStatusByLevel(level) {
    var levelsStatus = getLevelsStatus();
    return levelsStatus[parseInt(level) - 1];
}

//设置关卡通关状态
function setLevelStatusByLevel(level, isPass) {
    var levelsStatus = getLevelsStatus();
    levelsStatus[parseInt(level) - 1] = isPass.toString();
    saveData(localStorageKey.KEY_LEVEL_STATUS_STR, levelsStatus.join("-").toString());
}

//获取所有关卡提示解锁状态
function getLevelsTipsLockStatus() {
    var levelsTipsLockStatus = getData(localStorageKey.KEY_LEVEL_TIPS_LOCK_STATUS_STR);
    if (levelsTipsLockStatus == null || levelsTipsLockStatus == "") {
        levelsTipsLockStatus = "";
        for (var i = 1; i <= gameMaxLevel; i++) {
            levelsTipsLockStatus += i == gameMaxLevel ? "0" : "0-";
        }
    }
    return levelsTipsLockStatus.split("-");
}

//获取关卡提示解锁状态
function getLevelTipsLockStatusByLevel(level) {
    var levelsTipsLockStatus = getLevelsTipsLockStatus();
    return levelsTipsLockStatus[parseInt(level) - 1];
}

//设置关卡提示解锁状态
function setLevelTipsLockStatusByLevel(level, num) {
    var levelsTipsLockStatus = getLevelsTipsLockStatus();
    levelsTipsLockStatus[parseInt(level) - 1] = num.toString();
    saveData(localStorageKey.KEY_LEVEL_TIPS_LOCK_STATUS_STR, levelsTipsLockStatus.join("-").toString());
}

//获取金币数量
function getGoldNum() {
    var goldNum = getData(localStorageKey.KEY_GOLD_STR) || 10;
    return parseInt(goldNum);
}

//设置金币数量
function addGoldNum(num, isShow,isHideIcon) {
    num = parseInt(num) || 0;
    var goldNum = getGoldNum();
    goldNum += num;
    saveData(localStorageKey.KEY_GOLD_STR, "" + goldNum);

    //刷新当前场景的金币数量
    if (isShow) {
        showGoldChange(num,null,isHideIcon);
        refreshGoldStatus();
    } else {
        refreshGoldStatus();
    }

}

//获取是否首次打开
function getIsFirstOpen() {
    var isFirstOpen = getData(localStorageKey.KEY_IS_FIRST_OPEN);
    return isFirstOpen ? true : false;
}
function setIsFirstOpen() {
    saveData(localStorageKey.KEY_IS_FIRST_OPEN, true)
}

//获取上一次进入的关卡
function getSelectLevel(){
    var selectLevel=getData(localStorageKey.KEY_SELECT_LEVEL);
    return selectLevel || 1;
}

//设置当前进入的关卡
function setSelectLevel(level){
    saveData(localStorageKey.KEY_SELECT_LEVEL,level)
}

//获取音乐开关状态
function getMusicOffStatus() {
    var isMusicOff = getData(localStorageKey.KEY_MUSIC_OFF_STATUS_STR);
    if (isMusicOff != "0") {
        isMusicOff = "1"
    }
    return isMusicOff;
}

//设置音乐开关状态
function setMusicOffStatus(bool) {
    var isMusicOff = "0";
    if (bool)isMusicOff = "1";
    saveData(localStorageKey.KEY_MUSIC_OFF_STATUS_STR, isMusicOff);
}

//获取死亡次数
function getLossCount() {
    var lossCount = getData(localStorageKey.KEY_LOSS_COUNT_STR) || 0;
    return parseInt(lossCount);
}

//设置死亡次数
function addLossCount() {
    //关卡全通关后不添加死亡次数
    if (getIsLevelAllPass() != 0)return;

    var lossCount = getLossCount();
    lossCount += 1;
    saveData(localStorageKey.KEY_LOSS_COUNT_STR, lossCount);
}

//获取游戏总时长
function getGameTime() {
    var time = getData(localStorageKey.KEY_TIME_STR) || 0;
    return parseInt(time);
}

//设置游戏总时长
function setGameTime() {
    var timeDifference = getCurTime() - openTime;
    openTime = getCurTime();

    //关卡全通关后不添加游戏时间
    if (getIsLevelAllPass() != 0)return;
    var time = getGameTime() + timeDifference;
    saveData(localStorageKey.KEY_TIME_STR, time);
}

//获取当前时间
function getCurTime() {
    var time = 0;
    try {
        time = Math.round((new Date()).valueOf() / 1000);
    } catch (err) {
        trace("获取系统时间错误：" + err);
    }
    return time || 0;
}

//初始化视频按钮倒计时
function initVideoOpenDownTime() {
    videoDownTime.surplusTime = 60;
    videoDownTime.openTime = getCurTime();
}

//获取视频按钮倒计时
function getVideoDownTime() {
    if (videoDownTime.surplusTime > 0) {
        var timeDifference = getCurTime() - videoDownTime.openTime;
        videoDownTime.openTime = getCurTime();
        videoDownTime.surplusTime -= timeDifference;
    }
    if (videoDownTime.surplusTime < 0) {
        videoDownTime.surplusTime = 0;
    }
    return videoDownTime.surplusTime;
}

//获取关卡是否已经全通关
function getIsLevelAllPass() {
    var isLevelAllPass = getData(localStorageKey.KEY_IS_LEVEL_ALL_PASS) || 0;
    return isLevelAllPass;
}

//设置关卡已全通关
function setIsLevelAllPass(bool) {
    saveData(localStorageKey.KEY_IS_LEVEL_ALL_PASS, bool);
}

//获取已用兑换码列表
function getExchangeStr() {
    var exchangeStr = getData(localStorageKey.KEY_EXCHANGE_STR) || "";
    return exchangeStr;
}

//添加已用兑换码
function setExchangeStr(str) {
    var exchangeStr = getExchangeStr();
    if (exchangeStr.length > 0) {
        exchangeStr += "|" + str;
    } else {
        exchangeStr = str;
    }
    saveData(localStorageKey.KEY_EXCHANGE_STR, exchangeStr);
}

//获取是否已经购买新手礼包
function getIsBuyNovicePackage() {
    var isBuyNovicePackage = getData(localStorageKey.KEY_IS_BUY_NOVICE_PACKAGE) || 0;
    return isBuyNovicePackage;
}

//获取是否已经购买新手礼包
function setIsBuyNovicePackage(bool) {
    saveData(localStorageKey.KEY_IS_BUY_NOVICE_PACKAGE, bool);
}

//获取是否已经购买高手礼包
function getIsBuyMasterPackage() {
    var isBuyMasterPackage = getData(localStorageKey.KEY_IS_BUY_MASTER_PACKAGE) || 0;
    return isBuyMasterPackage;
}

//获取是否已经购买高手礼包
function setIsBuyMasterPackage(bool) {
    saveData(localStorageKey.KEY_IS_BUY_MASTER_PACKAGE, bool);
}

//获取是否已经购买攻略
function getIsBuyStrategy() {
    var isBuyStrategy = getData(localStorageKey.KEY_IS_BUY_STRATEGY) || 0;
    return isBuyStrategy;
}

//获取是否已经购买高手礼包
function setIsBuyStrategy(bool) {
    saveData(localStorageKey.KEY_IS_BUY_STRATEGY, bool);
}

//获取是否已经购买攻略
function getIsResetName() {
    var isResetName = getData(localStorageKey.KEY_IS_RESET_NAME) || 0;
    return isResetName;
}

//获取是否已经购买高手礼包
function setIsResetName(bool) {
    saveData(localStorageKey.KEY_IS_RESET_NAME, bool);
}

//设置审核开关
function setIsReview() {
    if (isMobile()) {
        if (CommonPlatform.getInstance().isReview()) {
            isReview = 1;
        } else {
            isReview = 0;
        }
    }
}

//添加关卡资源精灵缓存
function addLevelSpriteFrames(foldereName) {
    try {
        var isCurSpriteFrames = false;
        if (levelSpriteFrames.length > 0) {
            for (var i = 0; i < levelSpriteFrames.length; i++) {
                if (levelSpriteFrames[i].indexOf(foldereName) > 0) {
                    isCurSpriteFrames = true;
                } else {
                    var plist = levelSpriteFrames[i];
                    cc.spriteFrameCache.removeSpriteFramesFromFile(plist);
                    var png = plist.replace(/\.plist/, "");
                    cc.textureCache.removeTextureForKey(png);
//                trace("释放精灵缓存："+levelSpriteFrames[i]);

                    try {
                        cc.textureCache.removeUnusedTextures();
                    } catch (err) {
//                    trace("~~~清理无用缓存失败："+err);
                    }
                }
            }
            levelSpriteFrames = [];
        }

        var spriteFramesPath = getPlistPath(foldereName);
        if (spriteFramesPath) {
            if (!isCurSpriteFrames) {
                try {
                    cc.spriteFrameCache.addSpriteFrames(spriteFramesPath);
                    levelSpriteFrames.push(spriteFramesPath)
//                trace("添加关卡精灵帧文件完成————");
                } catch (err) {
//                trace("添加精灵帧缓存错误：" + err);
                }
            }
        }
    }catch(e){
        trace(e);
    }
}

//获取关卡对应的资源
function getPlistPath(foldereName, plistName) {
    if (foldereName) {
        try {
            if (plistName)plistName = plistName.replace(/\./g, "_");
            var levelSpriteFramesPath = eval("res_" + foldereName)[plistName || "spriteFrames_plist"];
            return levelSpriteFramesPath;
        } catch (err) {
            trace("plist找不到：" + err);
        }
    }
    return null;
}

//释放plist缓存(foldereName：文件夹名字,plistName：plist名字【可不填】)
function removePlistCache(foldereName, plistName) {
    if (foldereName) {
        try {
            var plist = getPlistPath(foldereName, plistName);
            if (plist) {
                cc.spriteFrameCache.removeSpriteFramesFromFile(plist);
                var png = plist.replace(/\.plist/, "");
                cc.textureCache.removeTextureForKey(png);
            }
        } catch (err) {
        }
    }
//    try{
//        cc.spriteFrameCache.removeUnusedSpriteFrames();
//    }catch(err){}
    try {
        cc.textureCache.removeUnusedTextures();
    } catch (err) {
    }
}

//添加plist缓存(foldereName：文件夹名字,plistName：plist名字【可不填】)
function addPlistCache(foldereName, plistName) {
    try {
        var plist = getPlistPath(foldereName, plistName);
        if (plist) {
            cc.spriteFrameCache.addSpriteFrames(plist);
//            trace("添加精灵缓存："+plist)
        }
    } catch (err) {
    }
}

function removeMainScenePlist(callback) {
    var plistList = [
        {
            type: "remove",
            folder: "MainScene",
            fileName: "spriteFrames.plist"
        },
        {
            type: "remove",
            folder: "levelSelect",
            fileName: "spriteFrames.plist"
        },
        {
            type: "add",
            folder: "GameOver",
            fileName: "spriteFrames.plist"
        },
        {
            type: "add",
            folder: "levelCommon",
            fileName: "spriteFrames.plist"
        },
        {
            type: "add",
            folder: "levelCommon",
            fileName: "spriteFrames2.plist"
        }
    ];

    if (sceneType == 0) {
        sceneType = 1;
        loadingPlist(plistList, callback);
    } else {
        if (callback)callback();
    }
}

function removeLevelScenePlist(callback) {
    var plistList = [
        {
            type: "remove",
            folder: "GameOver",
            fileName: "spriteFrames.plist"
        },
        {
            type: "remove",
            folder: "levelCommon",
            fileName: "spriteFrames.plist"
        },
        {
            type: "remove",
            folder: "levelCommon",
            fileName: "spriteFrames2.plist"
        },
        {
            type: "add",
            folder: "MainScene",
            fileName: "spriteFrames.plist"
        },
        {
            type: "add",
            folder: "levelSelect",
            fileName: "spriteFrames.plist"
        }
    ];

    if (sceneType == 1) {
        sceneType = 0;
        loadingPlist(plistList, callback);
    } else {
        if (callback)callback();
    }
}

function loadingPlist(plistList, callback) {
    var curScene = cc.director.getRunningScene();
    //var loading = new LoadingLayer();
    var loading = new PanelViewBase();
    loading.addToCurScene();

    if (plistList.length > 0) {
        var addList = [], removeList = [];
        for (var i = 0; i < plistList.length; i++) {
            if (plistList[i].type == "remove") {
                removeList.push(plistList[i]);
            } else {
                addList.push(plistList[i]);
            }
        }

        for (var j = 0; j < removeList.length; j++) {
            removePlistCache(removeList[j].folder, removeList[j].fileName);
        }


        var index = 0;
        curScene.runAction(cc.sequence(
            cc.callFunc(function () {
                if (index < addList.length) {
                    addPlistCache(addList[index].folder, addList[index].fileName);
                } else {
                    loading.onClose(function () {
                        if (callback)callback();
                    });
                }
                index++;
            }),
            cc.delayTime(0.0001)
        ).repeat(addList.length + 1));
    } else {
        if (callback)callback();
    }
}

//获取通关的进度
function getLevelPassProgress() {
    var levelsStatus = getLevelsStatus();
    var progress = 0;
    for (var i = 0; i < levelsStatus.length; i++) {
        if (levelsStatus[i] == 1) {
            progress++;
        } else {
            break;
        }
    }
    return progress;
}

//获取推荐应用数据
function getRecommend(data) {
    var recommendList;
    if (data) {
        var json = JSON.parse(data);
        if (json.data) {
            recommendList = json.data;
        } else {
            recommendList = json;
        }
    }
    trace("推荐应用数据:" + data);
    return recommendList;
}

//获取渠道名
function getChannel() {
    if (isMobile()) {
        return CommonPlatform.getInstance().getChannel();
    }
    return "";
}

//判断是否隐藏分享按钮
function isHideShare() {

    if (isMobile()) {
        if (getOnlineData("isOpenShare")!="true" || isReview == 1 || (isMobile("Android") && CommonPlatform.getInstance().getPkgName() != ("com.ipeaksoft." + gameKey)) || isHideOutChain() || getChannel() == "jinli") {
            return true;
        }
    } else if (isALLGameWeb == 1) {
        return true;
    }
    return false;
}

//是否隐藏外链
function isHideOutChain() {
    if (isMobile()) {
        switch (getChannel()) {
            case "uc":
            case "play":
            case "google":
                return true;
                break;
            default:
                break;
        }

        if(isReview==1){
            return true;
        }
    } else if (isALLGameWeb == 1) {
        return true;
    }
    return false;
}


//分享
function share(id, callback) {
    var shareWord,
        shareUrl,
        txt,
        title = "史小坑的烦恼2",
        url = "http://h5.kdyx.cn/" + gameKey,
        curLevel = _preSelectLevel < 10 ? "0" + _preSelectLevel : _preSelectLevel;



    switch (id) {
        case 1001://分享得金币
            txt = title;
            url = "http://kdyx.cn";
            break;
        case 1002://失败分享、求助分享
            txt = levelConfig[_preSelectLevel - 1]["helpWord"];
            break;
        case 1003://胜利分享
            txt = levelConfig[_preSelectLevel - 1]["winShareWord"];
            break;
        case 1004://全通关分享
            txt = "我居然全通关了，获得了“解毒大师”称号！";
            url = "http://kdyx.cn/";
            break;
        default :
            break;
    }


    if (isMobile()) {
        CommonPlatform.getInstance().umengCallBack = function (json) {
            try {
                json = JSON.parse(json);
                if (json.isSuccess) {
                    if (callback)callback();
                }
            } catch (err) {
            }
        }
        switch (id) {
            case 1001://分享得金币
                shareWord = getOnlineData("shareContents");
                if (shareWord && shareWord != "") {
                    txt = shareWord;
                }
                shareUrl = getOnlineData("shareUrl");
                if (shareUrl && shareUrl != "") {
                    url = shareUrl;
                }
                break;
            case 1002://失败分享、求助分享
                shareWord = getOnlineData("faileWord_" + getClassName(_preSelectLevel));
                if (shareWord && shareWord != "") {
                    txt = title+"求助：" + shareWord;
                }
                shareUrl = getOnlineData("shareUrl_" + getClassName(_preSelectLevel));
                if (shareUrl && shareUrl != "") {
                    url = shareUrl;
                } else {
                    url = "http://h5.kdyx.cn/" + gameKey + "/index.html?level=" + curLevel;
                }
                break;
            case 1003://胜利分享
                shareWord = getOnlineData("winWord_" + getClassName(_preSelectLevel));
                if (shareWord && shareWord != "") {
                    txt = title+"：" + shareWord;
                }
                shareUrl = getOnlineData("shareUrl_" + getClassName(_preSelectLevel));
                if (shareUrl && shareUrl != "") {
                    url = shareUrl;
                } else {
                    url = "http://h5.kdyx.cn/" + gameKey + "/index.html?level=" + curLevel;
                }
                break;
            case 1004://全通关分享
                shareWord = getOnlineData("allPassShareContents");
                if (shareWord && shareWord != "") {
                    txt = shareWord;
                }
                shareUrl = getOnlineData("allPassShareUrl");
                if (shareUrl && shareUrl != "") {
                    url = shareUrl;
                }
                break;
            default :
                break;
        }

        var olTitle = getOnlineData("shareTitle");
        if (olTitle && olTitle != "") {
            title = olTitle;
        }

        url="http://u.kdyx.cn/h3u";

        if (isMobile("iOS")) {
            CommonPlatform.getInstance().share(title, txt, "res/icon.png", url, id);
        } else if (isMobile("Android")) {
            CommonPlatform.getInstance().share(title, txt, "com.ipeaksoft." + gameKey + "/icon.png", url, id);
        }
    } else {
        if (isWeb > 0 && isBrowser()) {
            try {
                setShareConfig({
                    title: title,
                    link: "http://h5.kdyx.cn/" + gameKey + "/index.html?level=" + curLevel,
                    icon: "http://h5.kdyx.cn/" + gameKey + "/res/icon.png",
                    content: txt,
                    onSuccess: function () {
                        if (callback)callback();
                    },
                    onCancel: function () {
                    }
                });
            } catch (err) {
                trace("网络错误，不能分享!");
            }
        }
    }
}

//判断兑换码是否以兑换
function isExChange(str) {
    var exchangStr = getExchangeStr().split("|");
    for (var i = 0; i < exchangStr.length; i++) {
        if (exchangStr[i] == str) {
            return false;
        }
    }
    return true;
}

//判断购买是否成功（data:购买回调的数据）
function isBuySuccess(data) {
    if (data) {
        var json = JSON.parse(data);
        if (json["isSuccess"]) {
            return true;
        }
    }
    return false;
}

//获取在线参数
function getOnlineData(key,fn) {
    if (isMobile()) {
        if(_onlineDataList[key]){
            typeof fn == "function" && fn(_onlineDataList[key]);
            return _onlineDataList[key];
        }else {
            var onlineData = CommonPlatform.getInstance().getOnlineData(key);
            cc.log("在线参数【" + key + "】：" + onlineData + " , " + typeof fn);

            cc.log("JS__onlineDataList.length = "+Object.keys(_onlineDataList).length);
            cc.log("JS__onlineDataList = "+JSON.stringify(_onlineDataList));

            typeof fn == "function" && fn(onlineData);

            if (onlineData && onlineData != "" && onlineData != "null" && onlineData != "error json") {
                _onlineDataList[key] = onlineData.replace(/\u0000|\u0001|\u0002|\u0003|\u0004|\u0005|\u0006|\u0007|\u0008|\u0009|\u000a|\u000b|\u000c|\u000d|\u000e|\u000f|\u0010|\u0011|\u0012|\u0013|\u0014|\u0015|\u0016|\u0017|\u0018|\u0019|\u001a|\u001b|\u001c|\u001d|\u001e|\u001f/g,"");
                typeof fn == "function" && fn( _onlineDataList[key]);
                return _onlineDataList[key];
            }
        }
    }

    typeof fn=="function" && fn(false);
    return false;
}

//逻辑按钮
function isOpen(key){
    if(!isMobile())return false;
    return CommonPlatform.getInstance().isOpen(key);
}

//展示广告
function showAd(key){
    cc.log("JS：进入展示广告接口，当前广告位："+key);
    if(!isMobile()){
        return;
    }

    var overLevelAd=getOnlineData("overLevelAd") || 10;
    if(getLevelPassNum()>=overLevelAd){
        cc.log("JS：开始展示广告关卡："+ getOnlineData("overLevelAd"));
        CommonPlatform.getInstance().showAd(key,false);
    }
}

//获取关卡通关数量
function getLevelPassNum(){
    var levelStatus=getLevelsStatus();
    var passLevel=0;
    for(var i=0;i<levelStatus.length;i++){
        if(levelStatus[i]==1){
            passLevel++;
        }else{
            break;
        }
    }
    return passLevel;
}

function getFullScreen() {
    if(cc.winSize.width/cc.winSize.height<0.53) {
        return true;
    }else{
        return false;
    }
}

