/**
 * Created by weicheng on 15/10/6.
 *
 * 工具
 */

/*CSV工具*/
function CSVAnalyser(str, row, key) {
    var abc = getStrByRowAndKeyFromCSV(str, ",", row, key);
    return abc;
}
function getStrByRowAndKeyFromCSV(strData, strDelimiter, row, key) {
    strDelimiter = (strDelimiter || ",");
    var objPattern = new RegExp(
        (
            "(\\" + strDelimiter + "|\\r?\\n|\\r|^)" +

            "(?:\"([^\"]*(?:\"\"[^\"]*)*)\"|" +

            "([^\"\\" + strDelimiter + "\\r\\n]*))"
        ),
        "gi"
    );
    var arrData = [
        []
    ];
    var arrMatches = null;
    while (arrMatches = objPattern.exec(strData)) {
        var strMatchedDelimiter = arrMatches[1];
        if (
            strMatchedDelimiter.length &&
            (strMatchedDelimiter != strDelimiter)
        ) {
            arrData.push([]);
        }
        if (arrMatches[2]) {
            var strMatchedValue = arrMatches[2].replace(
                new RegExp("\"\"", "g"),
                "\""
            );
        } else {
            var strMatchedValue = arrMatches[3];
        }
        arrData[arrData.length - 1].push(strMatchedValue);
    }
    for (var i = 0; i < arrData[1].length; i++) {
        if (arrData[1][i] == key) {
            return arrData[row + 1][i]
        }
    }
    return "";
}
//CSV转Array
function CSVToArray(strData, strDelimiter) {
    strDelimiter = (strDelimiter || ",");
    var objPattern = new RegExp(
        (
            "(\\" + strDelimiter + "|\\r?\\n|\\r|^)" +
            "(?:\"([^\"]*(?:\"\"[^\"]*)*)\"|" +
            "([^\"\\" + strDelimiter + "\\r\\n]*))"
        ),
        "gi"
    );
    var arrData = [
        []
    ];
    var arrMatches = null;
    while (arrMatches = objPattern.exec(strData)) {
        var strMatchedDelimiter = arrMatches[1];
        if (
            strMatchedDelimiter.length &&
            (strMatchedDelimiter != strDelimiter)
        ) {
            arrData.push([]);
        }
        if (arrMatches[2]) {
            var strMatchedValue = arrMatches[2].replace(
                new RegExp("\"\"", "g"),
                "\""
            );
        } else {
            var strMatchedValue = arrMatches[3];
        }
        arrData[arrData.length - 1].push(strMatchedValue);
    }
    return arrData;
}

// 暂停当前场景所有子节点
function pauseAllNode() {
    var curScene = cc.director.getRunningScene();
    pauseNodeAllChildren(curScene);
}

// 恢复当前场景所有子节点
function resumeAllNode() {
    var curScene = cc.director.getRunningScene();
    resumeNodeAllChildren(curScene);
}


//遍历节点暂停所有子节点
function pauseNodeAllChildren(node) {
    if (node.getChildren().length > 0) {
        for (var i = 0; i < node.getChildren().length; i++) {
            node.getChildren()[i].pause();
            pauseNodeAllChildren(node.getChildren()[i]);
        }
    }
}
//遍历节点恢复所有子节点
function resumeNodeAllChildren(node) {
    if (node.getChildren().length > 0) {
        for (var i = 0; i < node.getChildren().length; i++) {
            node.getChildren()[i].resume();
            resumeNodeAllChildren(node.getChildren()[i]);
        }
    }
}

//暂停游戏
function _pauseGame() {
    pauseAllEffect();
    pauseMusic();
    pauseAllNode();
    var Scene = cc.director.getRunningScene();
    if (Scene.pauseTheGame)Scene.pauseTheGame();
}

//恢复游戏
function _resumeGame() {
    resumeAllEffect();
    resumeMusic();
    resumeAllNode();
    var Scene = cc.director.getRunningScene();
    if (Scene.pauseTheGame)Scene.resumeTheGame();
}

var effectArray = [];

// 播放音效
function playEffect(fileName, loop) {
    try {
        if (fileName) {
            if (effectArray.indexOf(fileName) == -1) {
                effectArray.push(fileName);
                var soundId = cc.audioEngine.playEffect(fileName, loop);
                cc.director.getRunningScene().runAction(cc.callFunc(function () {
                    effectArray = [];
                }));
                return soundId;
            }
        } else {
            trace("~~传入音效路径为空！");
        }
    } catch (err) {
        trace("找不到音效：" + err);
    }
}

//播放关卡目录音效（输入文件名即可）
function playLevelEffect(fileName, loop) {
    try {
        var audioPath, audioFile;
        try {
            audioPath = eval("res_levels_" + getClassName(_preSelectLevel) + "_sound");
        } catch (err) {
            audioPath = null;
        }
        if (!fileName.split(".")[1])fileName = fileName + ".mp3";
        fileName = fileName.replace(/\./g, "_");
        if (audioPath) {
            audioFile = audioPath[fileName];
        }
        if (!audioFile) {
            audioFile = res_sound[fileName];
        }
        if (isTestMode == 1) {
            trace("fileName:", audioFile);
        }
        return playEffect(audioFile, loop);
    } catch (err) {
        trace(err);
    }
}

// 停止音效
function stopEffect(soundId) {
    try {
        cc.audioEngine.stopEffect(soundId);
    } catch (err) {
        trace("停止音效失败：" + err);
    }
}

// 暂停音效
function pauseEffect(soundId) {
    try {
        cc.audioEngine.pauseEffect(soundId);
    } catch (err) {
        trace("暂停音效失败：" + err);
    }
}

// 恢复音效
function resumeEffect(soundId) {
    try {
        cc.audioEngine.resumeEffect(soundId);
    } catch (err) {
        trace("恢复音效失败：" + err);
    }
}

// 停止所有音效
function stopAllEffect() {
    try {
        cc.audioEngine.stopAllEffects();
    } catch (err) {
        trace("所有音效停止失败：" + err);
    }
}

// 暂停所有音效
function pauseAllEffect() {
    try {
        cc.audioEngine.pauseAllEffects();
    } catch (err) {
        trace("音效暂停失败：" + err);
    }

}

// 回复所有音效
function resumeAllEffect() {
    try {
        cc.audioEngine.resumeAllEffects();
    } catch (err) {
        trace("音效恢复错误：" + err);
    }
}

// 播放背影音乐
function playMusic(fileName, loop) {
    try {
        //切换音乐时，将停止上一次的背景音效
        stopMusic();
        trace(cc.audioEngine.playMusic(fileName, loop));
    } catch (err) {
        trace("找不到音乐：" + err);
    }
}

// 停止背景音乐
function stopMusic(release) {
    try {
        cc.audioEngine.stopMusic(release);
    } catch (err) {
        trace("停止背景音乐失败：" + err);
    }
}

// 暂停背景音乐
function pauseMusic() {
    try {
        cc.audioEngine.pauseMusic();
    } catch (err) {
        trace("背景音乐暂停失败：" + err);
    }
}

// 回复背景音乐
function resumeMusic() {
    try {
        cc.audioEngine.resumeMusic();
    } catch (err) {
        trace("音乐恢复错误：" + err);
    }
}

//屏幕的大小
function winSize() {
    var size = cc.director.getWinSize();
    return cc.size(size.width, size.height);
}

//屏幕的中心
function winCenter() {
    var winSize = cc.director.getWinSize();
    return cc.p(winSize.width / 2, winSize.height / 2);
}

/**创建按钮
 json={
     img:"res/photo.png",       //图片路径
     clickImg:"res/photo2.png", //点击后切换图片路径(可不填)
     callback:function(){},     //点击回调（可在创建按钮后再定义按钮的回调【例：btn.callback=function(){}】）
     swallow:true,              //是否吞噬下级事件
     clickScale:0.9             //点击缩放比例
     mode:1                     //按钮模式：默认不填（点击后在按钮范围内松开后发回调），1（点击后拖动一段距离松开按钮不触发回调）
     sound:"res/sound/click.png" //点击按钮音效（默认不填为：通用点击音效）
     soundOff:true              //音效开关（默认开启）
     txt:"显示的文本"             //创建label在精灵中心
     txtSize:18                 //文本大小（默认大小18）
     txtColor:cc.color(255,0,0) //字体颜色
  }

 sprite.setTouchEnabled(false); //设置关闭按钮触摸
 sprite.setString("文本");      //修改按钮精灵label文本（没有创建label的时候，会创建一个label）
 sprite.getString();            //获取按钮精灵label文本字符串
 sprite.getBtnLabel();         //获取按钮精灵label
 sprite.removeBtnLabel();       //删除当前按钮精灵label
 */
function createButton(json) {
    //优化
    if (typeof(json) == "string") {
        json = {img: json};
    }
    if (!json)return null;
    if (!json.img)return null;
    if (json.img.indexOf("/") == -1 && json.img.indexOf("#") == -1)json.img = getResImg(json.img);
    if (json.clickImg) {
        if (json.clickImg.indexOf("/") == -1 && json.clickImg.indexOf("#") == -1)json.clickImg = getResImg(json.clickImg);
    }

    var _spriteBtn = cc.Sprite.extend({
        _img: json.img,
        clickImg: json.clickImg,
        callback: json.callback,
        clickScale: json.clickScale,
        sound: json.sound,
        soundOff: json.soundOff,
        mode: json.mode,
        curPos_: null,
        distance_: null,
        __scale: 1,
        touchEnabled_: true,
        _btnLabel: null,
        txtSize: json.txtSize || 18,
        txtColor: json.txtColor || cc.color(0, 0, 0),
        autoTxtSize:(!!json.autoTxtSize) || false,
        onExit: function () {
            this._super();
            removeListener(this);
        },
        onEnter: function () {
            this._super();
            this.__scale = this.getScale();
            cc.eventManager.addListener({
                event: cc.EventListener.TOUCH_ONE_BY_ONE,
                swallowTouches: json.swallow != false ? true : false,
                onTouchBegan: function (touch, event) {
                    var target = event.getCurrentTarget();
                    if(touchBtnList.length>0)return false;
                    if (target.touchEnabled_ === false || !target.isVisible())return false;
                    var locationInNode = target.convertToNodeSpace(touch.getLocation());
                    var s = target.getContentSize();
                    var rect = cc.rect(0, 0, s.width * target.getScaleX(), s.height * target.getScaleY());
                    if (cc.rectContainsPoint(rect, locationInNode)) {
                        if (target.clickImg)target.changeTxture(target.clickImg);
                        target.scale = target.clickScale || target.__scale + 0.05;
                        target.curPos_ = touch.getLocation();
                        target.distance_ = 0;

                        touchBtnList.push(target);
                        return true;
                    }
                    return false;
                },
                onTouchMoved: function (touch, event) {
                    var target = event.getCurrentTarget();
                    var locationInNode = target.convertToNodeSpace(touch.getLocation());
                    var s = target.getContentSize();
                    var rect = cc.rect(0, 0, s.width * target.getScaleX(), s.height * target.getScaleY());
                    if (cc.rectContainsPoint(rect, locationInNode)) {
                        if (target.clickImg)target.changeTxture(target.clickImg);
                        target.scale = target.clickScale || target.__scale + 0.05;
                    } else {
                        if (target.clickImg)target.changeTxture(target._img);
                        target.scale = target.__scale;
                    }
                    target.distance_ += cc.pDistance(target.curPos_, touch.getLocation());
                },
                onTouchEnded: function (touch, event) {
                    var target = event.getCurrentTarget();
                    var index=touchBtnList.indexOf(target);
                    touchBtnList.splice(index,1);
                    var locationInNode = target.convertToNodeSpace(touch.getLocation());
                    var s = target.getContentSize();
                    var rect = cc.rect(0, 0, s.width * target.getScaleX(), s.height * target.getScaleY());
                    if (target.clickImg)target.changeTxture(target._img);
                    target.scale = target.__scale;
                    if (cc.rectContainsPoint(rect, locationInNode)) {
                        if (target.mode == 1 && target.distance_ > 40) {
                        }
                        else {
                            if (target.soundOff !== false) {
                                //playEffect(target.sound || res_sound.click_mp3);
                            }
                            if (target.callback)target.callback();
                        }
                    }
                },
                onTouchCancelled:function(touch,event){
                    var target = event.getCurrentTarget();
                    var index=touchBtnList.indexOf(target);
                    touchBtnList.splice(index,1);
                }
            }, this);
        },
        setTouchEnabled: function (bool) {
            this.touchEnabled_ = bool == false ? false : true;
        },
        changeTxture: function (txture) {
            setSpriteTxture(this, txture);
        },
        setString: function (txt) {
            if (this._btnLabel) {
                this._btnLabel.string = txt;
                this._btnLabel.fontSize=this.txtSize;
            } else {
                this._btnLabel = createLabel(txt, this.txtSize);
                this._btnLabel.attr({
                    x: this.width / 2,
                    y: this.height / 2,
                    color: this.txtColor
                });
                this.addChild(this._btnLabel);
            }

            if(this.autoTxtSize && this._btnLabel.width>this.width*0.85){
                var txtScale=Math.min(1,(this.width*0.85)/this._btnLabel.width);
                this._btnLabel.fontSize=this.txtSize*txtScale;
            }
        },
        getString: function () {
            return this.getBtnLabel() ? this.getBtnLabel().string : "";
        },
        getBtnLabel: function () {
            return this._btnLabel;
        },
        removeBtnLabel: function () {
            try {
                if (this._btnLabel) {
                    this._btnLabel.removeFromParent();
                    this._btnLabel = null;
                }
            } catch (err) {
                this._btnLabel = null;
            }
        }
    });

    var spriteBtn = new _spriteBtn(json.img);
    if (json.txt && json.txt != "")spriteBtn.setString(json.txt);

    return spriteBtn;
}


function createScale9Button(json) {
    if (!json)return null;
    if (!json.img)return null;
    if (json.img.indexOf("/") == -1 && json.img.indexOf("#") == -1)json.img = getResImg(json.img);
    json.img = json.img.replace(/#/g, "");
    if (json.clickImg) {
        if (json.clickImg.indexOf("/") == -1 && json.clickImg.indexOf("#") == -1)json.clickImg = getResImg(json.clickImg);
        json.clickImg = json.clickImg.replace(/#/g, "");
    }

    var scale9SpriteBtn = cc.Scale9Sprite.extend({
        _img: json.img,
        clickImg: json.clickImg,
        callback: json.callback,
        clickScale: json.clickScale,
        sound: json.sound,
        soundOff: json.soundOff,
        mode: json.mode,
        curPos_: null,
        distance_: null,
        __scale: 1,
        touchEnabled_: true,
        onExit: function () {
            this._super();
            cc.eventManager.removeListeners(this);
        },
        onEnter: function () {
            this._super();
            this.__scale = this.getScale();
            cc.eventManager.addListener({
                event: cc.EventListener.TOUCH_ONE_BY_ONE,
                swallowTouches: json.swallow != false ? true : false,
                onTouchBegan: function (touch, event) {
                    var target = event.getCurrentTarget();
                    if(touchBtnList.length>0)return false;
                    if (target.touchEnabled_ === false || !target.isVisible())return false;
                    var locationInNode = target.convertToNodeSpace(touch.getLocation());
                    var s = target.getContentSize();
                    var rect = cc.rect(0, 0, s.width * target.getScaleX(), s.height * target.getScaleY());
                    if (cc.rectContainsPoint(rect, locationInNode)) {
                        if (target.clickImg)target.changeTxture(target.clickImg);
                        target.scale = target.clickScale || target.__scale + 0.05;
                        target.curPos_ = touch.getLocation();
                        target.distance_ = 0;

                        touchBtnList.push(target);
                        return true;
                    }
                    return false;
                },
                onTouchMoved: function (touch, event) {
                    var target = event.getCurrentTarget();
                    var locationInNode = target.convertToNodeSpace(touch.getLocation());
                    var s = target.getContentSize();
                    var rect = cc.rect(0, 0, s.width * target.getScaleX(), s.height * target.getScaleY());
                    if (cc.rectContainsPoint(rect, locationInNode)) {
                        if (target.clickImg)target.changeTxture(target.clickImg);
                        target.scale = target.clickScale || target.__scale + 0.05;
                    } else {
                        if (target.clickImg)target.changeTxture(target._img);
                        target.scale = target.__scale;
                    }
                    target.distance_ += cc.pDistance(target.curPos_, touch.getLocation());
                },
                onTouchEnded: function (touch, event) {
                    var target = event.getCurrentTarget();
                    var index=touchBtnList.indexOf(target);
                    touchBtnList.splice(index,1);
                    var locationInNode = target.convertToNodeSpace(touch.getLocation());
                    var s = target.getContentSize();
                    var rect = cc.rect(0, 0, s.width * target.getScaleX(), s.height * target.getScaleY());
                    if (target.clickImg)target.changeTxture(target._img);
                    target.scale = target.__scale;
                    if (cc.rectContainsPoint(rect, locationInNode)) {
                        if (target.mode == 1 && target.distance_ > 40) {
                        }
                        else {
                            if (target.soundOff !== false) {
                                playEffect(target.sound || res_sound.click_mp3);
                            }
                            if (target.callback)target.callback();
                        }
                    }
                },
                onTouchCancelled:function(touch,event){
                    var target = event.getCurrentTarget();
                    var index=touchBtnList.indexOf(target);
                    touchBtnList.splice(index,1);
                }
            }, this);
        },
        setTouchEnabled: function (bool) {
            this.touchEnabled_ = bool == false ? false : true;
        },
        changeTxture: function (txture) {
            setScale9SpriteTexture(this, txture);
        }
    });

    return (new scale9SpriteBtn(json.img));
}

/**添加点击回调
 *
 * @param sprite 精灵
 * @param callback 回调
 * @param swallow   是否吞噬事件
 * @returns {*}
 */
function addTouchCallBack(sprite, callback, swallow, moveCallback) {
    removeListener(sprite);

    if (callback)sprite.callback = callback;
    if (moveCallback)sprite.moveCallback = moveCallback;
    sprite.touchEnabled_ = true;
    sprite.setTouchEnabled = function (bool) {
        this.touchEnabled_ = bool == false ? false : true;
    }.bind(sprite);

    cc.eventManager.addListener({
        event: cc.EventListener.TOUCH_ONE_BY_ONE,
        swallowTouches: swallow != false ? true : false,
        onTouchBegan: function (touch, event) {
            var target = event.getCurrentTarget();
            if(touchBtnList.length>1)return false;
            if (target.touchEnabled_ === false || !target.isVisible())return false;
            var locationInNode = target.convertToNodeSpace(touch.getLocation());
            var s = target.getContentSize();
            var rect = cc.rect(0, 0, s.width * target.getScaleX(), s.height * target.getScaleY());
            if (cc.rectContainsPoint(rect, locationInNode)) {
                if (target.beganCallback) {
                    var callback = target.beganCallback(touch, event);

                    if(typeof(callback) == "boolean"){
                        if(callback) {
                            touchBtnList.push(target);
                            return true;
                        }else{
                            return false;
                        }
                    }
                }
                touchBtnList.push(target);
                return true;
            }
            return false;
        },
        onTouchMoved: function (touch, event) {
            var target = event.getCurrentTarget();
            var deltaPos=touch.getDelta();  //偏移距离
            if (target.moveCallback)target.moveCallback(touch, event, deltaPos);
        },
        onTouchEnded: function (touch, event) {
            var target = event.getCurrentTarget();
            var index=touchBtnList.indexOf(target);
            touchBtnList.splice(index,1);
            var locationInNode = target.convertToNodeSpace(touch.getLocation());
            var s = target.getContentSize();
            var rect = cc.rect(0, 0, s.width * target.getScaleX(), s.height * target.getScaleY());
            if (cc.rectContainsPoint(rect, locationInNode)) {
                var touchChild=null;    //被点击的子类
                try{
                    //获取触碰到的子类
                    for(var i= target.children.length-1;i>=0;i--){
                        var child=target.children[i];
                        if(cc.rectContainsPoint(child.getBoundingBox(), locationInNode)){
                            touchChild=child;
                            break;
                        }
                    }
                }catch(e){
                    trace(e);
                }

                if (target.callback)target.callback(touch, event ,touchChild);
            }

            if (target.endCallback)target.endCallback(touch, event);
        },
        onTouchCancelled:function(touch,event){
            var target = event.getCurrentTarget();
            var index=touchBtnList.indexOf(target);
            touchBtnList.splice(index,1);
        }
    }, sprite);
}

//删除事件
function removeListener(obj) {
    try {
        cc.eventManager.removeListeners(obj);
    }catch(e){
        trace(e);
    }
}

/**创建计算坐标精灵（可拖动）
 * img      图片
 * tag      输出log后对应的tag
 * swallow  是否吞噬下面事件
 * */
function createPosSprite(img, tag, swallow) {
    var sprite;
    if (isTestMode == 1) {
        sprite = createLevelSprite(img);
        sprite.__tag = tag || "无标记";
        sprite.attr({
            x: winCenter().x,
            y: winCenter().y
        });

        function posLog(Event, target) {
            try {
                var pos = target.getParent().convertToWorldSpace(target.getPosition());
                var nodePos = target.getPosition();
                trace("~~~", Event, "~~~~");
                trace("目标tag:(" + target.__tag + ")，坐标:[" +
                    "\n\tpos【x:" + pos.x.toFixed(1) + ",y:" + pos.y.toFixed(1) +
                    "】，\n\twinPos【x:winCenter().x+" + (pos.x - winCenter().x).toFixed(1) + ",y:winCenter().y+" + (pos.y - winCenter().y).toFixed(1) +
                    "】，\n\tnodePos【x:" + nodePos.x.toFixed(1) + ",y:" + nodePos.y.toFixed(1) +
                    "】，\n\tnodeWinPos【x:" + (nodePos.x - target.getParent().width / 2).toFixed(1) + ",y:" + (nodePos.y - target.getParent().height / 2).toFixed(1) +
                    "】\n]");
                trace("~~~~~~~");
            } catch (err) {
            }
        }

        cc.eventManager.addListener({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: swallow != false ? true : false,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();
                if (target.touchEnabled_ === false || !target.isVisible())return false;

                posLog("began", target);

                var locationInNode = target.convertToNodeSpace(touch.getLocation());
                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);
                if (cc.rectContainsPoint(rect, locationInNode)) {
                    return true;
                }
                return false;
            },
            onTouchMoved: function (touch, event) {
                var target = event.getCurrentTarget();
                var delta = touch.getDelta();
                target.setPosition(cc.pAdd(target.getPosition(), delta));

                posLog("moved", target);
            },
            onTouchEnded: function (touch, event) {
                var target = event.getCurrentTarget();

                posLog("ended", target);
            }
        }, sprite);
    } else {
        sprite = createLevelSprite(arguments[0], arguments[1], arguments[2], arguments[3], arguments[4]);
    }

    return sprite;
}


/**
 * 获取动画(每帧用时，图片数组)
 *
 * 优化处理：
 * 1、可直接穿图片名字，不需要转全路径。
 * 2、重复图片帧资源优化。
 * by yutian.liu
 */
function getAnimation(time, arr) {
    if (arr) {
        try {
            //字符串动画处理
            for (var i = 0; i < arr.length; i++) {
                if (arr[i].indexOf("#") == -1 && arr[i].indexOf("/") == -1) {
                    arr[i] = getResImg(arr[i]);
                }
            }

            var animation;
            var oneImg = arr[0] ? arr[0].replace(/#/g, "") : arr[0];
            if (cc.spriteFrameCache.getSpriteFrame(oneImg)) {
                var animFrames = [];
                for (var i = 0; i < arr.length; i++) {
                    //此处做重复资源优化
                    var repeat = false;
                    for (var of = 0; of < animFrames.length; of++) {
                        if (arr[of] == arr[i]) {
                            repeat = true;
                            break;
                        }
                    }
                    //重复资源，则使用旧帧数据，否则使用新的帧数据
                    var frame = repeat ? animFrames[of] : cc.spriteFrameCache.getSpriteFrame(arr[i].replace(/#/g, ""));
                    //var frame = cc.spriteFrameCache.getSpriteFrame(arr[i].replace(/#/g,""));
                    animFrames.push(frame);
                }
                animation = new cc.Animation(animFrames, time);
            } else {
                animation = new cc.Animation();
                for (var i = 0; i < arr.length; i++) {
                    animation.addSpriteFrameWithFile(arr[i]);
                }
                animation.setDelayPerUnit(time);
            }

            var animate = cc.animate(animation);
            return animate;
        } catch (err) {
            trace("获取动画动作错误，动画动作换成延时动作:", err);
            return cc.delayTime(time);
        }
    } else {
        trace("~没有传入动画数组，改为返回延时动作！");
        return cc.delayTime(time);
    }
}

//添加动画（精灵，每帧用时，图片数组，是否循环（默认循环），函数）
function setAnimation(sprite, time, arr, loop, fn) {
    //@yutian.liu 优化，不会存在两个帧动画动作，多次set会进行覆盖。
    try {
        if (sprite.animationAction) {
            sprite.stopAction(sprite.animationAction);
            sprite.animationAction = null;
        }
    } catch (err) {
        //trace("停止动画错误：",err);
    }
    var animate = getAnimation(time, arr);
    if (!animate) {
        trace("获取动画动作出错，不执行动作的运行");
        return;
    }

    loop = (loop === false ? false : true);

    if (loop === true) {
        sprite.animationAction = cc.sequence(
            animate,
            cc.callFunc(fn, sprite)
        ).repeatForever();
    } else {
        sprite.animationAction = cc.sequence(
            animate,
            cc.callFunc(fn, sprite)
        );
    }
    sprite.runAction(sprite.animationAction);
}
//添加动画（精灵，每帧用时，图片数组，是否循环（默认循环），函数）
function setAnimationForLocal(sprite, time, arr, loop, fn) {
    var animate = getAnimation(time, arr);
    setAnimation(sprite, time, arr, loop, fn)
}

//创建精灵
function createSprite(img, rect) {
    var sprite = new cc.Sprite(img, rect);
    sprite._img = img;

    return sprite;
}

//创建9图精灵
function createScale9Sprite(img) {
    img = img.replace(/#/g, "");
    var sprite = new cc.Scale9Sprite(img);
    sprite._img = img;
    return sprite;
}

//创建关卡精灵
/**
 * @yutian.liu
 * @param imgName 传入创建的图片名字
 * @param time 传入间隔时间，要使用动画，此值不能为空
 * @param arr 如果此值不为空，则会创建动画
 * @param loop 是否循环
 * @param fun 是否需要播放回调
 * @returns {*}
 */
function createLevelSprite(imgName, time, arr, loop, fun) {
    var sprite = createSprite(getResImg(imgName));
    if (arr != null) {
        setAnimation(sprite, time, arr, loop, fun);
    }
    return sprite;
}

/**
 * <p>获取对应关卡的资源</p>
 在resource里面命名
 关卡资源命名
 var res_HelloWorldScene={
        abc_png:"res/HelloWorldScene/abc.png"
    }

 调用方法
 getResImg("abc","res_HelloWorldScene")
 或
 getResImg("abc.png","res_HelloWorldScene")
 */
function getResImg(imageName, searchPath) {
    if (!imageName)return null;
    var imagePath = null;
    imageName = imageName.replace(/#/g, "");
    var imgStr, Suffix;
    if (imageName.indexOf("/") != -1) {
        var imgStrArr = imageName.split("/");
        imgStr = imgStrArr[imgStrArr.length - 1];
    } else {
        imgStr = imageName;
    }
    if (imgStr.indexOf(".") != -1) {
        var imgStrSplit = imgStr.split(".");
        Suffix = imgStrSplit[1];
        if (Suffix == "")imgStr = imgStrSplit[0] + ".png";
    } else {
        imgStr = imgStr + ".png"
    }

    imgStr = imgStr.toString();
    if ((!Suffix || Suffix == "png") && cc.spriteFrameCache.getSpriteFrame(imgStr)) {
        imagePath = "#" + imgStr;
    } else {
        var resClassList = [
            "res_levels_" + getClassName(_preSelectLevel),
            "res_levelCommon",
            "res_common",
            "res_Panel",
            "res_webCommon",
            "res_Register",
            "res_effects",
            "res"
        ];

        if(imgSearchPath && imgSearchPath!="" && typeof(imgSearchPath)==="string")
            resClassList.unshift(imgSearchPath);

        imageName = imgStr.replace(/\./g, "_");
        if (searchPath) {
            try {
                if (searchPath.indexOf("res_") == -1)searchPath = "res_" + searchPath;
                imagePath = eval(searchPath) ? eval(searchPath)[imageName] : null;
            } catch (err) {
                imagePath = null;
            }
        }
        if (!imagePath) {
            //if(searchPath)trace("寻找路径：",searchPath,"，找不到资源");
            for (var i = 0; i < resClassList.length; i++) {
                try {
                    imagePath = eval(resClassList[i]) ? eval(resClassList[i])[imageName] : null;
                } catch (err) {
                    imagePath = null;
                }

                if (imagePath)break;
            }
        }
    }
    if (!imagePath)trace("查找图片【", imageName.replace(/_png/, ".png"), "】路径：", imagePath);
    return imagePath;
}

function getLevelImg(imageName, searchPath) {
    return getResImg(imageName, searchPath);
}

/**
 * <p>
 *     给指定Scene或Layer添加背景
 * </p>
 * @function
 * @param {String} bgFilePath:背景图片路径
 * @param {cc.Scene/cc.Layer} target:指定的Scene或Layer
 */
function addBackground(bgFilePath, target) {
    if (!bgFilePath) bgFilePath = getResImg("guanq_bg1.png");

    var bg = createSprite(bgFilePath);

    bg.setAnchorPoint(cc.p(0.5, 0));
    bg.y = 0;
    bg.x = cc.winSize.width / 2;

    target.addChild(bg, -100);
}


/**
 * <p>指定一个对象，让它可以抖动<p/>
 * <p>这是第二种震动效果，以放大缩小来实现的。<p/>
 * @function
 * @param {cc.Node} target:要抖动的对象，可以是场景，也可以是层，还可以是别的对象
 * @param {Number} times:要抖动的次数，如果值为-1，则表示永久抖动
 * @param {number} duration: 每一次抖动的时间间隔
 * @param {function} callback:抖动结束后要执行的回调函数
 *
 */
function shock(target, duration, times, callback) {

    if (!duration || duration == 0) duration = 0.01;
    if (!times || times == 0) times = 15;

    var actions = [
        cc.scaleTo(duration, 1.02),
        cc.scaleTo(duration, 1)
    ];
    if (!callback) actions.push(cc.callFunc(callback));

    var seq = cc.sequence(actions);

    if (times == -1) {
        seq.repeatForever();
    } else {
        seq.repeat(times);
    }

    target.runAction(seq);

}


/**
 * 判断当前设备
 * @param {String} os:判断的设备
 */
function isMobile(os) {
    var bool = false;
    if (os) {
        if (cc.sys.os == os && cc.sys.platform != 100 && cc.sys.platform != 101) {
            bool = true;
        } else {
            bool = false;
        }
    } else {
        if (cc.sys.isMobile && cc.sys.platform != 100 && cc.sys.platform != 101) {
            bool = true;
        }
    }
    return bool;
}

//判断当前是否为浏览器
function isBrowser(os) {
    var bool = false;

    if (os) {
        if (cc.sys.os == os && ( cc.sys.platform == 100 || cc.sys.platform == 101)) {
            bool = true;
        }
    } else if (cc.sys.platform == 100 || cc.sys.platform == 101) {
        bool = true;
    }
    return bool;
}

//设置声音开关
function setSoundOpenOrNot(isOpen) {
    if (isOpen) {
        cc.audioEngine.setEffectsVolume(1);
        cc.audioEngine.setMusicVolume(1);
        setMusicOffStatus(true);
    } else {
        cc.audioEngine.setEffectsVolume(0);
        cc.audioEngine.setMusicVolume(0);
        setMusicOffStatus(false);
    }
}

//消耗金币
function consumeGold(num, isShow, closeTipsCallback) {
    var curGoldNum = getGoldNum();
    num = parseInt(num);
    if (num <= curGoldNum) {
        addGoldNum(-num, isShow);
        return true;
    } else {
        if (closeTipsCallback)closeTipsCallback();
        if(!isMobile("iOS")){
            new StoreLayer().addToCurScene();
        }
    }
    return false;
}

//刷新关卡金币数量
function refreshGoldStatus() {
    var curScene = cc.director.getRunningScene();
    if (curScene && curScene._menuLayer) {
        curScene._menuLayer.txtLabel.setString("" + getGoldNum());
    }
}

//金币添加效果
function showGoldChange(gold, delay,isHideIcon) {
    var curScene = cc.director.getRunningScene();
    var winSize = cc.director.getWinSize();
    delay = delay || 0.0001;

    // if(!isHideIcon) {
    //     var key = createSprite(getResImg("guanq_btn_key.png"));
    //     key.attr({
    //         x: winSize.width + 100,
    //         y: -100
    //     });
    //     key.scale = 1.5;
    //     curScene.addChild(key, 100);
    //
    //     key.runAction(cc.sequence(
    //         cc.delayTime(delay),
    //         cc.spawn(
    //             cc.moveTo(0.7, cc.p(winSize.width / 2 - 25, winSize.height - 80)),
    //             cc.scaleTo(0.7, 1)
    //         ),
    //         cc.delayTime(0.2),
    //         cc.fadeOut(0.6),
    //         cc.removeSelf()
    //     ));
    // }

    gold = parseInt(gold);
    var goldStr = gold > 0 ? "+" + gold : gold;
    var word = createLabel(goldStr, 40);
    word.x = winSize.width + 100;
    word.y = -100;
    word.anchorX = 0;
    word.color = cc.color(252, 219, 118);
    word.scale = 1.5;
    curScene.addChild(word, 100);

    word.runAction(cc.sequence(
        cc.delayTime(delay),
        cc.spawn(
            cc.moveTo(0.7, cc.p(winSize.width / 2 - 10, winSize.height - 50)),
            cc.scaleTo(0.7, 1)
        ),
        cc.delayTime(0.2),
        cc.fadeOut(0.6),
        cc.removeSelf()
    ));

    refreshGoldStatus();
}

//设置精灵纹理
function setSpriteTxture(sprite, txture) {
    if (!txture)return;
    try {
        //获取精灵当前锚点
        var spriteAnchor = sprite.getAnchorPoint();

        //优化，可不传全路径
        txture = txture.indexOf("/") == -1 ? getResImg(txture) : txture;
        if (cc.spriteFrameCache.getSpriteFrame(txture.replace(/#/g, ""))) {
            sprite.setSpriteFrame(txture.replace(/#/g, ""));
        } else {
            sprite.initWithFile(txture);
        }
        sprite._img = txture;
        sprite.setAnchorPoint(spriteAnchor);
    } catch (err) {
        trace("报错的更换纹理：" + txture);
        trace(err);
    }
}

//设置9图精灵纹理
function setScale9SpriteTexture(sprite, txture) {
    if (!txture)return;
    if (cc.spriteFrameCache.getSpriteFrame(txture.replace(/#/g, ""))) {
        sprite.initWithSpriteFrameName(txture.replace(/#/g, ""));
    } else {
        sprite.initWithFile(txture);
    }
}


/**
 * 相对于屏幕中心点的偏移量转成坐标点
 * @param x
 * @param y
 * @returns {cc.Point|*}
 */
function limitToPosition(x, y) {
    return cc.p(winCenter().x + x, winCenter().y + y);
}

/**
 * 左右摇摆的动画
 * @param target 摇摆的对你
 * @param duration 时间间隔
 * @param deltaAngle 幅度
 * @param times 重复次数
 * @param callback 回调
 */
function rotate(target, duration, deltaAngle, times) {
    var seq = cc.sequence(
        cc.rotateBy(duration, deltaAngle),
        cc.rotateBy(duration, -deltaAngle)
    );

    if (times < 0) {
        seq = seq.repeatForever();
    } else {
        seq = seq.repeat(times);
    }

    target.runAction(seq);
}

/**
 * 延迟干某件事
 */
function delayTimeDoSomething(delay, callback) {
    cc.director.getRunningScene().getChildren()[0].runAction(cc.sequence(
        cc.delayTime(delay),
        cc.callFunc(function () {
            if (callback)callback();
        })
    ));
}

//显示提示文字
function showToast(txt, color) {
    if (txt) {
        var curScene = cc.director.getRunningScene();
        var winSize = cc.director.getWinSize();

        color = color || cc.color(255, 255, 255);

        var toast = createLabel(txt, 40, null, cc.size(winSize.width - 40, 120), cc.TEXT_ALIGNMENT_CENTER);
        toast.attr({
            x: winSize.width / 2,
            y: winSize.height / 2,
            color: color
        });
        curScene.addChild(toast, 99999);

        toast.runAction(cc.sequence(
            cc.spawn(
                cc.moveBy(1, cc.p(0, 100)),
                cc.fadeOut(1)
            ),
            cc.removeSelf()
        ));
    }
}

/**
 * 使一个精灵生动起来，实际是放大与缩小处理。
 */
function vivid(spr, scale) {
    try {
        if (!scale) scale = 0.02;
        spr.runAction(cc.sequence(cc.scaleTo(1, spr.scale + 0.02, spr.scale + 0.02), cc.scaleTo(1, spr.scale, spr.scale)).repeatForever());
    } catch (err) {
        trace(err)
    }
}

function addZero(num) {
    var sNum = num < 10 ? "0" + num : num;
    return sNum;
}


/**
 * 输出，忽略注释时把tarce函数中内容注释即可
 */
function trace() {
    try {
        if (arguments.length <= 1) {
            cc.log(arguments[0]);
        } else {
            var str = "";
            for (var i = 0; i < arguments.length; i++) {
                str += arguments[i];
            }
            cc.log(str);
        }
    } catch (err) {
        cc.log(err);
    }
}

/**检测字符串是否包含特殊字符*/
function checkStrSpecialChar(txt) {
    var pattern = new RegExp("[`~!@#$^&*()=|{}':;',\\[\\].<>/?~！@#￥……&*（）——|{}【】‘；：”“'。，、？]");
    if (pattern.test(txt)) {
        showToast("名字中不能包含\n特殊字符", cc.color(255, 0, 0));
        return true;
    }
    return false;
}


//调用当前场景失败界面
function showGameOver(faileKey, lossType) {
    var curScene = cc.director.getRunningScene();
    if (curScene.gameOver)curScene.gameOver(faileKey, lossType);
}

//调用当前场景胜利界面
function showGameWin(winWordKey, winType) {
    var curScene = cc.director.getRunningScene();
    if (curScene.gameWin)curScene.gameWin(winWordKey, winType);
}

//延时调用方法
function setDelay(sprite, time, func) {
    sprite.runAction(cc.sequence(cc.delayTime(time), cc.callFunc(func)));
}

//打开加速计(注意：不能在关卡ctor方法中直接调用)
function openAccelerometer() {
    var curScene = cc.director.getRunningScene();
    if (curScene.openAccelerometer)
        curScene.openAccelerometer();
}

//关闭加速计
function closeAccelerometer() {
    var curScene = cc.director.getRunningScene();
    if (curScene.closeAccelerometer)
        curScene.closeAccelerometer();
}

//设置当前场景中accCallback函数
function setAccCallback(callback) {
    if (typeof(callback) === "function") {
        var curScene = cc.director.getRunningScene();
        curScene.accCallback = callback;
    }
}

function createLabel(txt, size, color, box, hAlignment, vAlignment) {
    // var _fontFamliy = "AaQingCong";
    // if (isMobile("iOS") || isMobile("Android")) {
    //     _fontFamliy = "res/font/AaQingCong.ttf";
    // }
    var label = new cc.LabelTTF(txt || "", "Arial", size || 33, box, hAlignment, vAlignment);
    label.color = color || cc.color(62, 65, 67);

    return label;
}

function showWrong(x, y, scale,lossWordKey) {
    var curScene = cc.director.getRunningScene();
    if (curScene.gameWrong)curScene.gameWrong(x, y, scale);
}

function showRight(x, y, scaleX, scaleY) {
    var curScene = cc.director.getRunningScene();
    if (curScene.gameRight)curScene.gameRight(x, y, scaleX, scaleY);
}

//显示礼包 type:1(胜利)、2(失败)
function showPackage(type) {
    if (isMobile("Android")) {
        var overCount = _winCount + _faileCount;
        if(type==2 && showPurchaseHz>0 && _faileCount>0 && (_faileCount%showPurchaseHz==0)){
            new packageStoreLayer().addToCurScene();
        }
    }
}

//创建屏蔽触摸层,可以传入时间
function createUnTouchLayer(time,isAutoDelete){
    if(time && typeof(time).toLowerCase()!="number")
        time=null;

    var scene=cc.director.getRunningScene();
    var size = cc.director.getWinSize();
    var bg = new cc.LayerColor(cc.color(0, 0, 0,1), size.width, size.height);
    scene.addChild(bg, 1000);

    if(isAutoDelete!==false){
        bg.runAction(cc.sequence(
            cc.delayTime(time || 0.5),
            cc.removeSelf()
        ));
    }

    var listener1 = cc.EventListener.create({
        event: cc.EventListener.TOUCH_ONE_BY_ONE,
        swallowTouches: true,
        onTouchBegan: function (touch, event) {
            var target = event.getCurrentTarget();

            var locationInNode = target.convertToNodeSpace(touch.getLocation());
            var s = target.getContentSize();
            var rect = cc.rect(0, 0, s.width, s.height);

            if (cc.rectContainsPoint(rect, locationInNode)) {
                return true;
            }
            return false;
        },
        onTouchMoved: function (touch, event) {

        },
        onTouchEnded: function (touch, event) {
        }
    });
    cc.eventManager.addListener(listener1, bg);
}

//检测碰撞
function isHitTest(obj1,obj2){
    try{
        if(cc.rectIntersectsRect(obj1.getBoundingBox(),obj2.getBoundingBox())){
            return true;
        }
    }catch(e){
        cc.log(e);
    }
    return false;
}

/**
 * 创建矩形精灵
 * @param width 宽
 * @param height 高
 * @param color 颜色
 * @param opacity 透明度（0～255）
 */
function createRectSprite(width,height,color,opacity){
    var sprite=createSprite();
    sprite.setTextureRect(cc.rect(0,0,width || 100,height || 100));
    sprite.color=color || cc.color(255,0,0);
    sprite.opacity=opacity || 100;

    return sprite;

}

/**
 * 数组打乱
 * @param arr
 */
function arrUpSet(arr){
    for(var i=0;i<arr.length;i++){
        var random=Math.round(Math.random()*(arr.length-1));
        var value=arr[i];
        arr[i]=arr[random];
        arr[random]=value;
    }

    return arr;
}